// der Vorteil bei definitionen ist, wenn die Werte zu ändern sind, geschiet dies nur an 
// einer Stelle, nämlich am Programmkopf, ansonsten müßten sie im Programm durchsucht werden

#define warte_rt 500
#define warte_ge 300
#define warte_gn 300

#define warten 1000  // wird in millisekunden angegeben
#define LED_rt 13  
#define LED_gn 12
#define LED_ge 11
// ########################    E N D E     D  E  R     D  E  F  I  N  E  S    ###########



unsigned long timer;        // eine Variable die als long definiert ist, kann Werte bis 2^32 annhemen
unsigned long timer_alt_rt; 
unsigned long timer_alt_ge;
unsigned long timer_alt_gn;
unsigned int beispiel;          // eine Variable int also integer, kann Werte bis 65535 annehmen, unsigned bedeutet ohne Vorzeichen
boolean onoff_rt, onoff_ge, onoff_gn;                  // boolean belegt nur ein Bit, spart also Speicherplatz, damit speicher ich ob die LED ein oder aus ist
// ########################    E N D E     D  E  R     V  A R I A B L E N D E K L A R A T I O N E N    ###########




void setup() {
  // hier werden initialisierungen der Hardware und der Variablen vorgenommen 
  pinMode(LED_rt, OUTPUT); // hier wird der LED Port als Ausgang definiert
  digitalWrite(LED_rt,LOW);// LED ausschalten
  onoff_rt=0; // das bedeutet, die LED's sind aus; ich muss mir das merken, weil der Prozessor nicht weiss ob sein Pin ein oder aus ist.
  pinMode(LED_ge, OUTPUT); // hier wird der LED Port als Ausgang definiert
  digitalWrite(LED_ge,LOW);// LED ausschalten
  onoff_ge=0;
  pinMode(LED_gn, OUTPUT); // hier wird der LED Port als Ausgang definiert
  digitalWrite(LED_gn,LOW);// LED ausschalten
  onoff_gn=0; 
  
  timer_alt_rt=millis();  // beim Einschalten des Mikrocontrollers wird ein Zäher gestartet, der hier abgefragt wird
  timer_alt_ge=millis();
  timer_alt_gn=millis();
  
  // das ist ählich wie ein Garagentor, ob es offen oder zu ist, weiss ich auch erst wenn ich nachschaue oder wenn ich eine Lampe habe die es 
  // anzeigt. Diese Lampe ist in dem Programm die Variable onoff
  digitalWrite(LED_rt,HIGH);// LED einschalten, nur um zu zeigen, dass das Programm gestartet wurde
  delay(1000);
  digitalWrite(LED_rt,LOW);// LED ausschalten
}
//#######################  E  N  D  E    V  O  N    S  E  T  U  P  #########################




// im Gegensatz zu setup() wird loop, wieder der Name schon sagt, permanent durchlaufen
void loop() 
{
  timer=millis(); //lese den Zähler
  if(timer > timer_alt_rt + warte_rt)//schau ob die wartezeit bereits vergangen ist
  {// mit der geschweiften Klammer, werden Befehle "zusammen geschnürt", die nacheinander ausgeführt werden sollen
  // ohne die Klammern würde nur der Befehl ausgefürht, der unmittelbar nach der Bedingung folgt. Auch wenn nur ein Befehl
  // folgt wird die Klammer geschrieben, das dient auch der LEsbarkeit des Programms
    if (onoff_rt)// Frage: ist onoff == HIGH oder == 1  ??
    { // wenn ja dann schalte LED aus
      digitalWrite(LED_rt, LOW);
      onoff_rt=0;// zeige an, dass LED aus ist
      timer_alt_rt=millis();
    }
    else
    { 
      digitalWrite(LED_rt, HIGH);
      onoff_rt=1;// merke dir, dass LED eingeschaltet wurde
      timer_alt_rt=millis();
    }// ende von else 
  }// ender der timer abfrage

  timer=millis(); //lese den Zähler
  if(timer > timer_alt_ge + warte_ge)//schau ob die wartezeit bereits vergangen ist
  {
    if (onoff_ge)// Frage: ist onoff == HIGH oder == 1  ??
    { // wenn ja dann schalte LED aus
      digitalWrite(LED_ge, LOW);
      onoff_ge=0;// zeige an, dass LED aus ist
      timer_alt_ge=millis();
    }
    else
    { 
      digitalWrite(LED_ge, HIGH);
      onoff_ge=1;// merke dir, dass LED eingeschaltet wurde
      timer_alt_ge=millis();
    }// ende von else 
  }// ender der timer abfrage

  timer=millis(); //lese den Zähler
  if(timer > timer_alt_gn + warte_gn)//schau ob die wartezeit bereits vergangen ist
  {
    if (onoff_gn)// Frage: ist onoff == HIGH oder == 1  ??
    { // wenn ja dann schalte LED aus
      digitalWrite(LED_gn, LOW);
      onoff_gn=0;// zeige an, dass LED aus ist
      timer_alt_gn=millis();
    }
    else
    { 
      digitalWrite(LED_gn, HIGH);
      onoff_gn=1;// merke dir, dass LED eingeschaltet wurde
      timer_alt_gn=millis();
    }// ende von else 
  }// ender der timer abfrage
}// ############## e  n  d  e    v  o  n     l  o  o  p     ###############################
