#define LED_rt 13  // beim uno sind die Pins von 0 .. 13 durchnummeriert
#define Taster 8  // Taster S1 ist an Port 8 angeschlosen
// ########################    E N D E     D  E  R     D  E  F  I  N  E  S    ###########
// ########################    E N D E     D  E  R   Unterprogramm - D E K L A R A T I O N E N    ###########
boolean onoff_rt, pulled;       
// ########################    E N D E     D  E  R     V  A R I A B L E N     ###########
void setup() {
  pinMode(LED_rt, OUTPUT); // hier wird der LED Port als Ausgang definiert
  pinMode(Taster, INPUT_PULLUP);// Pin 8 wird gleichzeitig als Eingang und mit Widerstand auf 5V definiert
  digitalWrite(LED_rt,LOW);// LED ausschalten
  onoff_rt=0; //
  pulled=0;   // nicht gedrückt
  digitalWrite(LED_rt,HIGH);// LED einschalten, nur um zu zeigen, dass das Programm gestartet wurde
  delay(1000);
  digitalWrite(LED_rt,LOW);// LED ausschalten
}
//#######################  E  N  D  E    V  O  N    S  E  T  U  P  #########################
// im Gegensatz zu setup() wird loop, wieder der Name schon sagt, permanent durchlaufen
void loop() 
{
  pulled=digitalRead(Taster);// mit dem Befehl digitalRead(Pin) kann man den Zustand am Pin einlesen

  if(pulled == LOW)
  {
   delay(30);
   pulled=digitalRead(Taster);// schauen ob gedrückt
   if(!pulled) // ist identisch mit  if(pulled == LOW)
   {
    if (onoff_rt)// Frage: ist onoff == HIGH oder == 1  ??
    { // wenn ja dann schalte LED aus
      digitalWrite(LED_rt, LOW);
      onoff_rt=0;// zeige an, dass LED aus ist
    }
    else
    { 
      digitalWrite(LED_rt, HIGH);
      onoff_rt=1;// merke dir, dass LED eingeschaltet wurde
    }// ende von else 
   } // ende von  if(!pulled)
  } // ende von if(pulled == LOW)

  do// diese Schleife wartet darauf, dass der Taster wieder losgelassen wird
  {
     pulled=digitalRead(Taster);// schauen ob gedrückt
     delay(10);
  }
  while(!pulled);   // so lange der Taster gedrückt ist, ist pulled=0, durch das Negierungszeichen 
                    // ist die Aussage innerhalb der Klammern wahr, also wird die while schleife weiter ausgeführt
                    // nach dem loslassen ist pulled=1 und somit wird die Abfrage zu  while(0), damit wird while nicht mehr ausgeführt
}// ############## e  n  d  e    v  o  n     l  o  o  p     ###############################
