#define analog A0  // An welchem Pin wurde der Sensor angeschlossen
// #define digital 2  // an welchem Pin des arduino wurde der digitalausgang des Sensors angeschlosssen
#define normal 2000 // wenn keine Grenzwertüberschreitung, dann reicht alle 2s eine Nachricht
#define warning 500 // wenn der Grenzwert überschritten, dann sende 2 Botschaften in der Sekunde
#define warm_up 10  //   wie lange will ich dem Sensor Zeit geben sich warm zu machen
#define LED 9       // LED anklemmen
#define Buzzer 10   // Basiswiderstand für Transistor
#define triggerLevel 300  // wenn der Wert über triggerLevel liegt soll nun ausgelöst werden
unsigned int CO_val;  // der Analogwert wird als integer abgespeichert
boolean status_val;   // der Digitalwert hat nur zwei Zustände
boolean s_trigger;    // speichere ob der Alarm ausgelöst wurde

void setup() 
{
  unsigned int c;    // brauche eine Variable für die for - Schleife
  Serial.begin(9600);// aktiviere die serielle Schnittstelle
  //pinMode(digital, INPUT);// der Pin 2 des arduino wird nun als Eingang definiert
  pinMode(LED, OUTPUT);
  pinMode(Buzzer,OUTPUT);
  digitalWrite(LED,LOW);
  digitalWrite(Buzzer,LOW);
  Serial.println(" Warte bis der erste Aufwärmvorgang beendet ist   ");
  for(c=0; c < warm_up; c++)// jede Sekunde soll ausgegeben werden, wie lange die Aufwärmphase dauert
  {
    Serial.print(warm_up-c,DEC);
    Serial.print("s ...");
  }
  Serial.println();
  Serial.println("beendet!!!");
  s_trigger=0;
}

void loop() 
{
  //status_val=digitalRead(digital);
  CO_val=analogRead(analog);
  if (CO_val > triggerLevel) //status_val wird nicht mehr mit dem Signal vom Sensor gesetzt, sondern wenn triggerLEvel überschritten ist
  { status_val =1; }
  else
  { status_val =0; }
  Serial.write("gelesen wurde folgender Wert vom Sensor: "); 
  Serial.println(CO_val,DEC);
  if(!status_val)
  { Serial.println(" ACHTUNG  !!!   Wert überschritten");}

  delay(normal);
  if(status_val)
  {
    delay(normal);
  }
  else
  {
    delay(warning);
  }

  if((status_val) &&(!s_trigger))// ich will den Alarmpiepser nur einmal durchlaufen, daher s_trigger
  {// s_trigger ist 0 und wird erst auf 1 gesetzt, wenn der Alarm einmal ausgelöst wurde
      digitalWrite(Buzzer,HIGH);
      delay(1000);
      digitalWrite(Buzzer,LOW);
      delay(300); digitalWrite(Buzzer,HIGH);
      delay(1000);
      digitalWrite(Buzzer,LOW);
      delay(300);
       digitalWrite(Buzzer,HIGH);
      delay(1000);
      digitalWrite(Buzzer,LOW);
      delay(300);// es wurde dreimal gepiepst

      digitalWrite(LED,HIGH); // jetzt ist die LED auch ein
      s_trigger=1; // der Alarm wurde ausgelöst, das merke ich mir mit dieser Variablen
  }
  
}
