#include <SoftwareSerial.h>

#define RX 2  // 
#define TX 3  // 
// da die Ports unterschiedliche Funktionen haben, gibt es auch diverse Namen, sie anzusprechen
#define c_warte 1200  // die Wartezeit bis zur Antwort des ESP-Moduls, koennte auch viel kuerzer sein
#define BAUD_ESP_LOW 9600 
#define BAUD_ESP_HIGH 115200
#define BAUD_PC  115200

// nun wird eine serielle Schnittstelle generiert, die mit ESP12 statt mit serial angesprochen wird
SoftwareSerial ESP12(RX, TX); // serial soll signalisieren, es handelt sich um eine im Prozessor eingebaute Schnittstelle
              // ESP12 ist jedoch allein eine von Software verwaltete und gesteuerte Schnittstelle
              // der Arduino nano hat nur eine Hardwareschnittstelle und die braucht er zur Kommunikation mit dem PC!

unsigned long millis_old, millis_akt; // möchte mir die Zeitstempel merken
unsigned int  delta;                  // um zu berechnen wie viel Zeit vergangen ist
char v_read[10];                          // eine Variable für das Empfangsbyte
unsigned int f,a;                     // Laufvariable für for-Schleife und array
boolean b_OK;

void setup()
{
  Serial.begin(BAUD_PC);// initialisieren Schnittstelle zum PC/Notebook
 
}



void loop() // run over and over
{
  ESP12.begin(BAUD_ESP_HIGH);// initialisiere Schnittstelle zu ESP12 und schau ob Modul angeschlossen ist
  b_OK=0;
  ESP12.print("AT\r\n");

  millis_old=millis();
  do
  {
    millis_akt=millis();
    delta = millis_akt - millis_old;
  }
  while((ESP12.available() == 0) && (delta <= c_warte)); // Daten sollten innerhalb der Wartezeit locker vorhanden sein
    
  if(delta >= c_warte)
  { // wenn keine Daten empfangen werden:
    Serial.println("kein ESP-Modul angeschlossen?");
  }
  else // nun sollten Daten anliegen:
  {
    a=0;
    delay(10); // warte bis alle Daten im Empfangspuffer
    do
      {
        v_read[a]=ESP12.read();
        if(v_read[a] > 20)//speichere nur die ASCII-Zeichen im Array
        { 
          Serial.print(v_read[a]); 
          if(v_read[a]=='O')
          {
             a++;
             v_read[a]=ESP12.read();
             if(v_read[a]=='K')
              { b_OK=1;}
          }
          else
          { a++; }
        }
        else
        { Serial.print(' '); }
        
        
        //Serial.println(ESP12.available(),DEC); // wie viele Daten sind augenblicklich im Empfangspuffer
      } 
    while(ESP12.available() > 0);    // lese bis der Empfangspuffer leer ist.
    
    // Serial.print("a: ");Serial.println(a,DEC); wie viele Zeichen wurden eingelesen
    
    for(f=0; f < a; f++)// gib nun die im Array gespeicherten Zeichen aus
      { Serial.print(v_read[f]); }
      Serial.println();//neue Zeile einfügen am Ende es Array
  }
  if(b_OK)
 { Serial.println("Kommumikation OK");}
 while(1); // nun soll das Programm stehen bleiben
}
