#include <SoftwareSerial.h>

#define RX 2  // 
#define TX 3  // 
// da die Ports unterschiedliche Funktionen haben, gibt es auch diverse Namen, sie anzusprechen
#define c_warte 1200  // die Wartezeit bis zur Antwort des ESP-Moduls, koennte auch viel kuerzer sein
#define BAUD_ESP_LOW 9600 
#define BAUD_ESP_HIGH 115200
#define BAUD_PC  115200

// nun wird eine serielle Schnittstelle generiert, die mit ESP12 statt mit serial angesprochen wird
SoftwareSerial ESP12(RX, TX); // serial soll signalisieren, es handelt sich um eine im Prozessor eingebaute Schnittstelle
              // ESP12 ist jedoch allein eine von Software verwaltete und gesteuerte Schnittstelle
              // der Arduino nano hat nur eine Hardwareschnittstelle und die braucht er zur Kommunikation mit dem PC!

unsigned long millis_old, millis_akt; // möchte mir die Zeitstempel merken
unsigned int  delta;                  // um zu berechnen wie viel Zeit vergangen ist
char v_read[10];                          // eine Variable für das Empfangsbyte
unsigned int f,a;                     // Laufvariable für for-Schleife und array
boolean b_OK;

boolean test_connect(unsigned long p_baudrate);


void setup()
{
  Serial.begin(BAUD_PC);// initialisieren Schnittstelle zum PC/Notebook
}
// ende von setup ########################
//########################################


void loop() // run over and over
{
  if(test_connect(BAUD_ESP_HIGH))
    { Serial.println("Kommumikation OK");}
  while(1); // nun soll das Programm stehen bleiben
}
// ende von loop() ########################
//#########################################



boolean test_connect(unsigned long p_baudrate)
{
  char c;
  boolean b;
  
  ESP12.begin(p_baudrate);// initialisiere Schnittstelle zu ESP12 und schau ob Modul angeschlossen ist
  b=0;
  ESP12.print("AT\r\n");

  millis_old=millis();
  do
  {
    millis_akt=millis();
    delta = millis_akt - millis_old;
  }
  while((ESP12.available() == 0) && (delta <= c_warte)); // Daten sollten innerhalb der Wartezeit locker vorhanden sein
    
  if(delta >= c_warte)
  { // wenn keine Daten empfangen werden:
    Serial.println("kein ESP-Modul angeschlossen?");
  }
  else // nun sollten Daten anliegen:
  {
    delay(10); // warte bis alle Daten im Empfangspuffer
    do
      {
        c=ESP12.read();
        if(c > 20) 
        { 
          Serial.print(c); 
          if(c == 'O')
          {
             c=ESP12.read();
             Serial.print(c);
             if(c == 'K') 
              { b=1;}
          }
        }
        else
         { Serial.print(' '); }
    } 
    while(ESP12.available() > 0);    // lese bis der Empfangspuffer leer ist.
    Serial.println();                // füge eine neue Zeile ein
  }
  return b;
}
