// zweck diese Programms ist es einen AT String zu senden
// und abzuwarten ob ein OK zurückkommt

#include <SoftwareSerial.h>


#define c_warte_Daten 2000 // wartezeit, bis alle Daten uebertragen, kann auch laenger sein
#define RX 2  // 
#define TX 3  // 
// da die Ports unterschiedliche Funktionen haben, gibt es auch diverse Namen, sie anzusprechen
#define c_warte 3000  // die Wartezeit bis zur Antwort des ESP-Moduls, koennte auch viel kuerzer sein
#define BAUD_ESP_LOW 9600 
#define BAUD_ESP_HIGH 115200
#define BAUD_PC  115200
// nun wird eine serielle Schnittstelle generiert, die mit ESP12 statt mit serial angesprochen wird
SoftwareSerial ESP12(RX, TX); // serial soll signalisieren, es handelt sich um eine im Prozessor eingebaute Schnittstelle
              // ESP12 ist jedoch allein eine von Software verwaltete und gesteuerte Schnittstelle
              // der Arduino nano hat nur eine Hardwareschnittstelle und die braucht er zur Kommunikation mit dem PC!

unsigned long millis_old, millis_akt; // möchte mir die Zeitstempel merken
unsigned int  delta;                  // um zu berechnen wie viel Zeit vergangen ist
char v_read;//[10];                     // eine Variable für alle Empfangsbytes
boolean b_OK;                       // befehl fuer Zeilenumbruch; boolean, weil nur wichtig ist ob da oder noch nicht da
unsigned int f,a;                      // Laufvariable für char - array und for - schleife
void setup()
{
  Serial.begin(BAUD_PC);// initialisieren Schnittstelle zum PC/Notebook
}

void loop() // run over and over
{
  ESP12.begin(BAUD_ESP_HIGH);// initialisiere Schnittstelle zu ESP12 und schau ob Modul angeschlossen ist
  b_OK=0;             // setze boolean standardmässig auf 0
  //Serial.print(" Sende Abfrage: AT");
  ESP12.print("AT\r\n");
  //Serial.println(" warte auf Echo: ");
  
  millis_old=millis();
  do
  {
    millis_akt=millis();
    delta = millis_akt - millis_old;
  }
  while((ESP12.available() == 0) && (delta <= c_warte_Daten)); // Daten sollten innerhalb der Wartezeit locker vorhanden sein
    
  if(delta > c_warte_Daten)
  { // wenn keine Daten empfangen werden:
    Serial.println("kein ESP-Modul angeschlossen?");
  }
  else // nun sollten Daten anliegen:
  {
    //Serial.print("echo: ");
    delay(10); // warte bis alle Daten im Empfangspuffer, sollte aber auch schneller gehen (ca. 1ms)
    b_OK=0;
    millis_old=millis();
    do
    {
      v_read=ESP12.read();
      if(v_read > 20)
      {
        Serial.print(v_read);
        if(v_read == 'O')//naechter Buchstabe soll K sein dann b_OK=1 !!
        {
          v_read=ESP12.read();
          Serial.print(v_read);
          if(v_read == 'K')
            { b_OK=1; }
          else // Text geht weiter, bin nicht am ENDE
            { Serial.print("O");  } // das O wuerde sonst verschluckt werden, 
        }                            // denn jetzt ist bereits das K in der Emofangsvariable v_read gespeichert
        //Serial.print(v_read);
      }
      else
        { Serial.print(' '); }
      millis_akt=millis();
      delta = millis_akt - millis_old;
    } 
    while((ESP12.available() > 0));// && (b_OK==0) && (delta < c_warte_Daten));    // lese bis der Empfangspuffer leer ist.
    //while((b_OK==0) && (delta < c_warte_Daten));    // lese bis der Empfangspuffer leer ist.
    
  }// ende else
  
  if(b_OK)
  { Serial.println(" Kommunikation OK "); }
  
  while(1); // nun ist das Programm beendet und bleibt in der Schleife stehen
}
