#include <SoftwareSerial.h>

#define RX 2  // 
#define TX 3  // 
// da die Ports unterschiedliche Funktionen haben, gibt es auch diverse Namen, sie anzusprechen
#define c_warte 1200  // die Wartezeit bis zur Antwort des ESP-Moduls, koennte auch viel kuerzer sein
#define BAUD_ESP 9600 //115200
#define BAUD_PC  115200

// nun wird eine serielle Schnittstelle generiert, die mit ESP12 statt mit serial angesprochen wird
SoftwareSerial ESP12(RX, TX); // serial soll signalisieren, es handelt sich um eine im Prozessor eingebaute Schnittstelle
              // ESP12 ist jedoch allein eine von Software verwaltete und gesteuerte Schnittstelle
              // der Arduino nano hat nur eine Hardwareschnittstelle und die braucht er zur Kommunikation mit dem PC!

unsigned long millis_old, millis_akt; // möchte mir die Zeitstempel merken
unsigned int  delta;                  // um zu berechnen wie viel Zeit vergangen ist
char v_read;                          // eine Variable für das Empfangsbyte


void setup()
{
  Serial.begin(BAUD_PC);// initialisieren Schnittstelle zum PC/Notebook
  ESP12.begin(BAUD_ESP);// initialisiere Schnittstelle zu ESP12 und schau ob Modul angeschlossen ist
}



void loop() // run over and over
{
  // ESP12.println("AT"); // erwarte als Echo AT ... OK

  // ESP12.println("ATE0"); // damit läßt sich die Funktion Echo abschalten. Es wird der Befehl nicht zurückgegeben, damit vereinfacht sich u.U. die Programmierung, weil 
                         // weniger Zeichen ausgewertet und abgefragt werden müssen.
  // ESP12.println("ATE1"); // dmit kann die Echo-Funktion wieder angeschaltet werden

  // ESP12.println("AT+GMR"); // diese Befehlsfolge zeigt die Firmware Version an. Diese kann u.U. unterschiedliche AT-Befehle besitzen                        

  // ESP12.println("AT+CWMODE");// in welchem Mode arbeitet das Wifi-Modul: 0: Client 1: access point oder 3: beides

  // ESP12.println("AT+RFPOWER=50");  // damit lässt sich die Sendeleitung einstellen; erlaubt: 0 ... 82

  
  millis_old=millis();
  do
  {
    millis_akt=millis();
    delta = millis_akt - millis_old;
  }
  while((ESP12.available() == 0) && (delta <= c_warte)); // Daten sollten innerhalb der Wartezeit locker vorhanden sein
    
  if(delta >= c_warte)
  { // wenn keine Daten empfangen werden:
    Serial.println("kein ESP-Modul angeschlossen?");
  }
  else // nun sollten Daten anliegen:
  {
    delay(10); // warte bis alle Daten im Empfangspuffer, sollte aber auch schneller gehen (ca. 1ms)
    do
      {
        v_read=ESP12.read();
        if(v_read > 20)
        { Serial.print(v_read); }
        else
        { Serial.print(' '); }
        //Serial.println(ESP12.available(),DEC); // Daten einlesen und ausgeben zum PC
      } 
    while(ESP12.available() > 0);    // lese bis der Empfangspuffer leer ist.
    Serial.println();// Zeilenumbruch nach jedem Durchlauf
  }
  delay(5000);// zeit wurde auch willkuerlich gewaehlt
}
