// Leider zu wenig Speicher für das Vorhaben


// Zweck dieses Programmes ist es, alle verfuegbaren Acces Points anzuzeigen und zu analysieren
//
// dies geschieht mit dem Befehl:
// AT+CWLAP 
// die Antwort soll hier weiter betrachtet und analysiert (aufgeschluesselt) werden:
// enc,   wie ist das Signal kodiert 0= gar nicht ... 7 = WPA2_WPA3_PSK das sind Verschluesslungsverfahren, die eingefuehrt wurde, 
//        die, die Datenuebertragung sicherer zu machen, je groesser die Zahl, desto groesser die Sicherheit

// ssid   ist der Name des acces point

// -dBm   ist die Empfangsfeldstärke, je kleiner das Signal, desto Stärker die Sendeleistung, bzw. desto näher ist der Sender

// MAC    adresse ist die physikaliesche Adresse eines Netzwerteilnehmers

// Kanal  ueblich sind in Deutschland: 1, 6 und 11 in Nordamerika: 1,7 und 13




// dazu zuerst alle Daten in ein array speichern und dann sortieren

#include <SoftwareSerial.h>


#define RX 18  // D18 ist AN4(SCL), dieser Pin soll empfangen
#define TX 19  // D19 ist AN5(SDA), dieser Pin soll senden
// da die Ports unterschiedliche Funktionen haben, gibt es auch diverse Namen, sie anzusprechen
#define c_warte 3000  // die Wartezeit bis zur Antwort des ESP-Moduls, die Abfrage kann auch laenger sein
                      // je nachdem wie viele Teilnehmer der ESP abfragen muss.
#define c_warte_Daten 5000  // wartezeit, bis alle Daten uebertragen, kann auch laenger sein
#define anz_ap 25           // anzahl möglicher access points
#define anz_zeichen 50      // anzahl der Zeichen: (verschluesselung[1],"Name des AP"[26],-dBm[3],"MAC-adresse"[17},Kanal[3])
                            //  in [] stehen wie viele Zeichen für die jeweilige Variable reserviert sind

                            
                            // nun wird eine serielle Schnittstelle generiert, die mit ESP8266 statt mit serial angesprochen wird
SoftwareSerial ESP8266(RX, TX); // serial soll signalisieren, es handelt sich um eine im Prozessor eingebaute Schnittstelle
                                // ESP8266 ist jedoch allein eine von Software verwaltete und gesteuerte Schnittstelle
                                // der Arduino nano hat nur eine Hardwareschnittstelle und die braucht er zur Kommunikation mit dem PC!



unsigned long millis_old, millis_akt; // möchte mir die Zeitstempel merken
unsigned int  delta;                  // um zu berechnen wie viel Zeit vergangen ist
char v_read;                          // eine Variable für das Empfangsbyte
boolean v_CRLF;                       // befehl fuer Zeilenumbruch; boolean, weil nur wichtig ist ob da oder noch nicht da
unsigned char v_ap, v_char;           // Laufvariable im v_empfang array für access point [0 ... anz_ap-1] und fuer das jeweilige empfangene Zeichen [0 ... anz_zeichen-1] 
//char v_empfang[anz_ap][anz_zeichen];  // Reserviere Daten im RAM fuer die empfangenen Zeichen
char datensatz[1000];
unsigned int f;                       // Laufvariable oder Hilfsvariable
unsigned int count;                // wie viele bytes wurden eingelesen

//------------------- S E T U P ( ) --------------------------------------------------------------------------
void setup()
{
  Serial.begin(19200);// initialisieren Schnittstelle zum PC/Notebook
  ESP8266.begin(9600);// initialisiere Schnittstelle zu ESP8266 und schau ob Modul angeschlossen ist
  v_CRLF=0;
  v_ap=0;
  v_char=0;
}


//---------------- l o o p  ( ) ----------------------------------------------------------------------------------------------
void loop() // run over and over
{
  Serial.print("Sende Abfrage: ");
  ESP8266.println("AT+CWLAP");
  Serial.println("warte auf Echo: ");
  
  millis_old=millis();
  do
  {
    millis_akt=millis();
    delta = millis_akt - millis_old;
  }
  while((ESP8266.available() == 0) && (delta <= c_warte)); // Daten sollten innerhalb der Wartezeit locker vorhanden sein

    
  if(delta >= c_warte)
  { // wenn keine Daten empfangen werden:
    Serial.println("kein ESP-Modul angeschlossen?");
  }
  else // nun sollten Daten anliegen:
  {
    delay(10); // warte bis alle Daten im Empfangspuffer, sollte aber auch schneller gehen (ca. 1ms)
    do
    {
      v_read=ESP8266.read();
      if(v_read > 20)
        {  Serial.print(v_read);     }
      else
        { Serial.println(); v_CRLF=1; } // wenn /r für CR oder /n für LF empfangen wurde, dann beende das Einlesen
    } 
    while((ESP8266.available() > 0) && (v_CRLF == 0));    // lese das Echo bis der Empfangspuffer leer ist.
  
  
    //nun warte auf die richtigen Daten, dies dauert ein wenig bis alle Access Points eingelesen sind
    Serial.println("warte auf   D A T E N  ... ");
    v_CRLF=0;
    millis_old=millis();
    f=0;
    do
    {
      millis_akt=millis();
      delta = millis_akt - millis_old; 
      if(ESP8266.available() != 0)
      {  
        v_read=ESP8266.read(); 
        datensatz[f]=v_read;
        f++;
                                            // wenn OK empfangen wurde, dann ist Datensatz komplett
        if(v_read == 'O')                   //naechter Buchstabe soll K sein dann v_CRLF=1 !!
        { v_CRLF=1; }                       // zeige, dass 'O' da war
        if((v_read == 'K') &&(v_CRLF == 1))// wenn nach dem O das K gesendet wird, dann beenden
        { v_CRLF=2;}
        else                               // Falls nicht, dann warte auf neue Buchstabenfolge mit O und K
        { v_CRLF=0;}
      }   
    }
    while((ESP8266.available() > 0) && (v_CRLF == 2) && (delta < c_warte_Daten));    // lese bis der Empfangspuffer leer ist.
    count=f-3;// merke mir, wie viele Daten empfangen wurden O und K zaehlen nicht und f wird immer um eins weitergezaehlt, bevor daten ins array geschrieben werden
  }// ende von else

  for(f=0; f <= count; f++)
  {
    Serial.print(datensatz[f]);
    if(f % 20 == 0)
    { Serial.println();} 
  }
while(1);
/*
  // jetzt die Daten des Datensatzes sortieren und im Datensatz: v_empfang ablegen ----------------------------------------------------------------------------------
  do
  {
    if(ESP8266.available() !=0)
    {
      v_read=ESP8266.read();
      Serial.print(v_read);
      if(v_read == '(' )// ab da beginnen die gesuchten Informationen
      { 
        do
        {
          if(ESP8266.available() !=0)
          {
              v_read=ESP8266.read();
              Serial.print(v_read);
              
              if((v_read !='"') && (v_read != ','))// beginnt oder endet hier ein Parameter ?
              {                                   // wenn keine Endekennung dann
                v_empfang[v_ap][v_char]=v_read;   // speichere das Zeichen im Array
                v_char++;                         //zeige auf das naechste Zeichen      
              }
              else // wenn " oder , empfangen werden
              {
                if(v_read == ',') // wenn Komma, dann schauen ob das naechste Zeichen " ist, dann einlesen bis " und evtl rest mit ' ' auffüllen
                {// dann sollte naechstes Zeichen " sein, und wenn nicht ???
                 v_read=ESP8266.read();
                 if(v_read == '"')              // hier beginnt ein neuer Parametersatz
                 {
                    v_read=ESP8266.read();
                    v_empfang[v_ap][v_char]=v_read;// speichere das Zeichen nach dem 'O' im Array
                    v_char++;                     //zeige auf das naechste Zeichen                          
                 }
                }

                if(v_read == '"')             // wenn Komma, dann schauen ob das naechste Zeichen , 
                {
                  v_read=ESP8266.read();
                  if(v_read == ',')            // jetzt folgt naechster Rueckgabeparameter 
                  {
                    v_read=ESP8266.read();
                    v_empfang[v_ap][v_char]=v_read;// speichere das Zeichen nach dem 'O' im Array
                    v_char++;                     //zeige auf das naechste Zeichen                          
                   
                    if(v_read == '-')        // jetzt folgt rssi als Rueckgabeparameter 
                    {
                      if((v_char > 1) && (v_char < 27)) // dann muss ich den Namen mit Leerzeichen auffuellen
                      {
                        for(f=v_char; f < 27; f++)
                          { v_empfang[v_ap][f]=' '; }
                        v_char=27;
                        // erst nach dem auffuellen der Leerzeichen kann der dBm Parameter gelesen und gespeichert werden
                        do
                        {
                            v_read=ESP8266.read();
                            v_empfang[v_ap][v_char]=v_read;// speichere das Zeichen nach dem 'O' im Array
                            v_char++;                     //zeige auf das naechste Zeichen                          
                        }
                        while(v_read != ','); // so lange einlesen bis alle Zeichen im Parametersatz enthalten sind
                        if(v_char == 28)// wenn v_char == 28, dann zweimal links schieben, und mit '  ' auffuellen, weil Zahl nur einstellig
                        {
                          v_empfang[v_ap][29]=v_empfang[v_ap][27];
                          v_empfang[v_ap][28]=' ';
                          v_empfang[v_ap][27]=' ';
                        }
                      
                        if(v_char == 29)// wenn v_char == 29, dann  einmal links schieben, und mit ' ' auffuellen, weil Zahl nur zweistellig
                        {
                          v_empfang[v_ap][29]=v_empfang[v_ap][28];
                          v_empfang[v_ap][28]=v_empfang[v_ap][27];
                          v_empfang[v_ap][27]=' ';
                        } 
                      // wenn v_char == 30, ist Zahl dreistellig und alles passt wie es ist
                      
                      }
                    }
                    else // dann kann es nur Parameter fuer den Kanal sein
                    {
                      if(v_char == 47)  // dann muss ich die Ziffer in dreistelligen char umwandeln wie dBm
                      {
                          v_empfang[v_ap][48]=v_empfang[v_ap][47];
                          v_empfang[v_ap][47]=' ';
                      }
                    }
                  }
                }//ende von if(v_read == '"')
              }// ende von else
            }
          }
          while(v_read != ')');             // solange Info einlesen bis ')', dann ist Datensatz zu ende 
                                            //Wenn OK, dann fertig wenn nicht beginnt naechster Datensatz
          v_ap++;                           // bereit fuer naechsten DAtensatz
          Serial.println();                 // Bereite Ausgabe für naechsten Datensatz vor
        }
      
        if(v_read == 'O')                   //naechter Buchstabe soll K sein dann v_CRLF=1 !!
        {
          v_read=ESP8266.read();
          if(v_read == 'K')
          { 
            v_CRLF=1; 
            v_ap--;                          // wenn K empfangen wurde, dann wurde v_ap zu frueh erhoeht
            Serial.print("O");               // das O wuerde sonst verschluckt werden, 
                                             // denn jetzt ist bereits das K in der Emofangsvariable v_read gespeichert
          }
          else                               // Text geht weiter, bin nicht am ENDE
          { 
            v_empfang[v_ap][v_char]='O';// speichere das Zeichen im Array
            v_char++;            //zeige auf das naechste Zeichen  
            v_empfang[v_ap][v_char]=v_read;// speichere das Zeichen nach dem 'O' im Array
            v_char++;            //zeige auf das naechste Zeichen                          
          }
        }
      }  
      millis_akt=millis();
      delta = millis_akt - millis_old;
  } 
  //while((ESP8266.available() > 0) && (v_CRLF==0) && (delta < c_warte_Daten));    // lese bis der Empfangspuffer leer ist.
  while((v_CRLF == 0) && (delta < c_warte_Daten));    // lese bis der Empfangspuffer leer ist.
   
  while(1); // nun ist das Programm beendet und bleibt in der Schleife stehen
  */
}
