// Zweck dieses Programmes ist es, alle verfuegbaren Acces Points anzuzeigen
//
// dies geschieht mit dem Befehl AT + CWLAP 


#include <SoftwareSerial.h>
//###########  ende der   I N C L U D E S              #########################################################
//--------------------------------------------------------------------------------------------------------------

#define c_warte_Daten 3000      // wartezeit, bis alle Daten uebertragen, kann auch laenger sein
#define RX 2  // 
#define TX 3  // 
// da die Ports unterschiedliche Funktionen haben, gibt es auch diverse Namen, sie anzusprechen
#define c_warte 30000           // die Wartezeit bis zur Antwort des ESP-Moduls, koennte auch viel kuerzer sein
#define BAUD_ESP_HIGH 115200
#define BAUD_ESP_LOW 9600
#define BAUD_PC  115200
//###########  ende der # d e f i n e Deklarationen              #########################################################
//-------------------------------------------------------------------------------------------------------------------------

                                // nun wird eine serielle Schnittstelle generiert, die mit ESP12 statt mit serial angesprochen wird
SoftwareSerial ESP12(RX, TX);   // serial soll signalisieren, es handelt sich um eine im Prozessor eingebaute Schnittstelle
                                // ESP12 ist jedoch allein eine von Software verwaltete und gesteuerte Schnittstelle
                                // der Arduino nano hat nur eine Hardwareschnittstelle und die braucht er zur Kommunikation mit dem PC!
//------------------------------------------------------------------------------------------------------------------------------------------

unsigned long millis_old, millis_akt; // möchte mir die Zeitstempel merken
unsigned int  delta;                  // um zu berechnen wie viel Zeit vergangen ist
char v_read;                          // eine Variable für das Empfangsbyte
boolean v_CRLF;                       // befehl fuer Zeilenumbruch; boolean, weil nur wichtig ist ob da oder noch nicht da
boolean baud_high, b_OK;
//------------------------------------------------------------------------------------------------------------------------------
//###########  ende der V a r i a b l e n - deklarationen              #########################################################
//------------------------------------------------------------------------------------------------------------------------------

boolean test_baud(unsigned long p_baudrate);// übergebe paramter: baudrate und prüfe ob Kommunikation möglich und gib true oder flase zurück
void change_BAUD(unsigned long p_baudrate); // über gebde die neue BAUD-Rate als Parameter, im Programm wird der entsprechende AT-Befehl gesendet     
unsigned char read_char(void);                  // erwarte und lese die Antwort vom PC (Eingabe: 1 oder 0)  !              
//------------------------------------------------------------------------------------------------------------------------------
//###########  ende der Funktionsdeklarationen              #########################################################
//-------------------------------------------------------------------------------------------------------------------

void setup()
{ 
  Serial.begin(BAUD_PC); // initialisieren Schnittstelle zum PC/Notebook
  Serial.println("teste Verbindung zu ESP-Modul");
  delay(100);// muss warten, weil sonst Fehler in der Kommunikation mit ESP-Modul, aber bisher Ursache ungeklärt
  if(test_baud(BAUD_ESP_HIGH))
  { Serial.println("Kommunikation high: OK");}
  else 
   { 
    Serial.println("Kommunikation high: nicht OK");
    if(test_baud(BAUD_ESP_LOW))
      { Serial.println("Kommunikation low : OK");}
    else 
      { Serial.println("Kommunikation low : nicht OK");}
   }   
  // while(1);  // nur bis hierher, für Testzwecke
  delay(100);
  
} 
//###############################################################################################################
// e n d   o f     s e t u p ()    ##############################################################################
//###############################################################################################################



void loop() // run over and over
{

  if(test_baud(BAUD_ESP_LOW))// wenn Baudrate low speed frage ob auf high speed umgestellt werden soll
    { Serial.println("gib 1 für Umstellung auf High_speed ein:"); }
  else if(test_baud(BAUD_ESP_HIGH))// wenn die Baudrate auf Highspeed ist
    {  Serial.println("gib 0 für Umstellung auf low_speed ein:"); }
  else // wenn beides nicht klappert dann keine Kommunikation
    { Serial.println("keine Kommunikation "); }

  if(read_char() == '1') // wenn '1' eingegeben wurde
  { 
    //Serial.println(" eins erkannt ");
    change_BAUD(BAUD_ESP_HIGH);
  }
  else if(read_char() == '0') // wenn '1' eingegeben wurde
  { 
    Serial.println(" 0 erkannt ");  
    change_BAUD(BAUD_ESP_LOW);
  }  
  Serial.println(" drücke RESET am Arduino NANO für Neustart, um BAUDrate erneut zu ändern");
  while(1);
}
//###############################################################################################################
// e n d   o f     l o o p () ###################################################################################
//###############################################################################################################


unsigned char read_char(void)              // erwarte und lese die Antwort vom PC und unterscheide ob high=1 oder low=0 eingegeben wurde, andere Eingaben sind nicht erlaubt        
{
  unsigned char back;                     // Rückgabewert
  millis_old=millis();
  do
  {
    millis_akt = millis();
    delta = millis_akt - millis_old;// wie lange wird die Schleife schon durchlaufen?
    if(Serial.available() > 0)
    { 
      v_read=Serial.read(); 
      if (v_read < 20)
      { v_read=Serial.read(); }
      else if((v_read != '0') && (v_read != '1')) 
         { Serial.print("bist du dumm? ");Serial.println(v_read); }   // wenn die Eingabe weder 0 noch 1 ist
    }  
  }
  while(( v_read != '0' ) && ( v_read != '1' ) && ( delta <= c_warte )); // Daten sollten innerhalb der Wartezeit locker vorhanden sein

  

  if( delta <= c_warte)
  {
    if(v_read == '1')
      { back='1'; } // wenn 0 dann 9600 wenn 1 dann 115200
    else
      { back='0'; } 
  }
  else
  { 
    Serial.println("Du warst zu langsam - Schnecke"); 
    back='x';
  }
  return(back);
}
//###############################################################################################################
// e n d   o f     r e a d _ c h a r ()    ######################################################################
//###############################################################################################################
void change_BAUD(unsigned long p_baudrate)  // Baudrate soll auf p_Baudrate umgestellt werden
{  
  
    if(p_baudrate == BAUD_ESP_HIGH)// aktuell ist high spped am Modul eingestellt
    {
      ESP12.begin(BAUD_ESP_LOW);// initialisiere Schnittstelle mti aktueller Baudrate
      Serial.print(" Sende Befehl AT + UART_DEF = 115200 Baud ,8 Datenbits ,1 Stop ,0 Parity ,0 = kein RTS und kein CTS");
      delay(100);
      ESP12.println("AT+UART_DEF=115200,8,1,0,0");
    }
    else if(p_baudrate == BAUD_ESP_LOW)// wenn low speed am Modul
    {
      ESP12.begin(BAUD_ESP_HIGH);// initialisiere Schnittstelle mit aktueller Baudrate
      Serial.print(" Sende Befehl AT + UART_DEF = 9600Baud ,8 Datenbits ,1 Stoppbit ,0 Paritybits ,0 hardware handshake"); //stelle um
      delay(100);
      ESP12.println("AT+UART_DEF=9600,8,1,0,0");
      
    }
    //Serial.println(" warte auf Echo mit alter Baudrate: ");
    delay(10);
    millis_old=millis();
    do
    {
      millis_akt = millis();
      delta = millis_akt - millis_old;// wie lange wird die Schleife schon durchlaufen?
      if(Serial.available() > 0)
      { 
       v_read=Serial.read(); 
       Serial.println(v_read); 
      }  
    }
    while((Serial.available() > 0) && ( delta <= c_warte ));
    Serial.println();
    Serial.println("--------------------------------");
    Serial.print(" teste mit neuer Baudrate: ");Serial.println(p_baudrate,DEC);
    Serial.print(" Umstellung auf ");
    delay(100);
    if(test_baud(p_baudrate))
    {Serial.print(p_baudrate,DEC);Serial.println(" hat geklappt");}
    else
    {Serial.print(p_baudrate,DEC);Serial.println(" hat nicht geklappt");}

}
//###############################################################################################################
// e n d   o f     c h a n g e _ B A U D ()    ##################################################################
//###############################################################################################################


boolean test_baud(unsigned long p_baudrate)
// größtenteils wurde diese Funktion aus dem Beispiel ESP12_BSP1.ino übernommen
{
  boolean b;
  ESP12.begin(p_baudrate);
  b=0;
  ESP12.print("AT\r\n");
  millis_old=millis();
  do
  {
    millis_akt=millis();
    delta = millis_akt - millis_old;
  }
  while((ESP12.available() == 0) && (delta <= c_warte_Daten)); // Daten sollten innerhalb der Wartezeit locker vorhanden sein
    
  if(delta > c_warte_Daten)
  { // wenn keine Daten empfangen werden:
    // Serial.println("keine Kommunikation möglich");
  }
  else // nun sollten Daten anliegen:
  {
    delay(10); // warte bis alle Daten im Empfangspuffer, sollte aber auch schneller gehen (ca. 1ms)
    millis_old=millis();
    do
    {
      v_read=ESP12.read();
     
      if(v_read == 'O')//naechter Buchstabe soll K sein dann b_OK=1 !!
      {
        v_read=ESP12.read();
        if(v_read == 'K')
          { b=1; }
      }                           // denn jetzt ist bereits das K in der Emofangsvariable v_read gespeichert
      millis_akt=millis();
      delta = millis_akt - millis_old;
    } 
    while((ESP12.available() > 0) && (b == 0) && (delta < c_warte_Daten));    // lese bis der Empfangspuffer leer ist.
    //while((b == 0 ) && (delta < c_warte_Daten));    // lese bis der Empfangspuffer leer ist.
  }// ende else

  while(ESP12.available() > 0)  // lese den Empfangspuffer leer, sollte \r\n im Puffer sein
  {  v_read=ESP12.read();  }
  return (b);
}
//###############################################################################################################
// e n d   o f     t e s t _ b a u d ()  ########################################################################
//###############################################################################################################
