#include <SoftwareSerial.h>

#define RX 2  // 
#define TX 3  // 
// da die Ports unterschiedliche Funktionen haben, gibt es auch diverse Namen, sie anzusprechen
#define c_warte 3000  // die Wartezeit bis zur Antwort des ESP-Moduls, koennte auch viel kuerzer sein
#define BAUD_ESP_HIGH 115200
#define BAUD_ESP_LOW 9600
#define BAUD_PC  115200

// nun wird eine serielle Schnittstelle generiert, die mit ESP12 statt mit serial angesprochen wird
SoftwareSerial ESP12(RX, TX); // serial soll signalisieren, es handelt sich um eine im Prozessor eingebaute Schnittstelle
              // ESP12 ist jedoch allein eine von Software verwaltete und gesteuerte Schnittstelle
              // der Arduino nano hat nur eine Hardwareschnittstelle und die braucht er zur Kommunikation mit dem PC!

unsigned long millis_old, millis_akt; // möchte mir die Zeitstempel merken
unsigned int  delta;                  // um zu berechnen wie viel Zeit vergangen ist
char v_read;                          // eine Variable für das Empfangsbyte


void setup()
{
  Serial.begin(BAUD_PC);// initialisieren Schnittstelle zum PC/Notebook
  ESP12.begin(BAUD_ESP_LOW);// initialisiere Schnittstelle zu ESP12 und schau ob Modul angeschlossen ist
}



void loop() // run over and over
{
  ESP12.print("AT+CWLAP\r\n");

  millis_old=millis();
  do
  {
    millis_akt=millis();
    delta = millis_akt - millis_old;
  }
  while((ESP12.available() == 0) && (delta <= c_warte)); // Daten sollten innerhalb der Wartezeit locker vorhanden sein
    
  if(delta >= c_warte)
  { // wenn keine Daten empfangen werden:
    Serial.println("kein ESP-Modul angeschlossen?");
  }
  else // nun sollten Daten anliegen:
  {
    delay(10); // warte bis alle Daten im Empfangspuffer, sollte aber auch schneller gehen (ca. 1ms)
    millis_old=millis();
    do
      {
        v_read=ESP12.read();
        if(v_read == '+')
        {Serial.println();}// neue Zeile einfügen, wegen Übersichtlichkeit
        if(v_read > 20)
        { Serial.print(v_read); }
        else if((v_read == '\r') || (v_read == '\n'))
        { Serial.print(' '); }
        //Serial.println(ESP12.available(),DEC); // Daten einlesen und ausgeben zum PC
        millis_akt=millis();
        delta = millis_akt - millis_old;
      } 
    while((ESP12.available() > 0) || (delta <= c_warte));    // lese bis der Empfangspuffer leer ist.
    Serial.println();// Zeilenumbruch nach jedem Durchlauf
  }
  while(1);
}
