// Als erstes beginnen wir mit einem einfachen Beispiel
// Damit wollen wir nur testen, ob wir eine Verbindung zum ESP8266 erhalten
// Wir können leider nicht die vorhandene Schnittstelle RX und TX nutzen, denn diese 
// benötigt die Arduino IDE um mit dem arduino zu kommunizieren.
// Deshalb brauchen wir eine zusätzliche Schnittstelle. Diese ist aber beim uno, nano, mini nict vorhanden.
// Ein Abhilfe ist, diese als Software zu generieren. Das bedeutet, wir nutzen einen beliebigen I/O-Port
// Die Signale werden im Hintergrund per Software geschaltet und eingelesen. Das Timing übernimmt dabei auch die Software.
// Das alles kostet natürlich Rechenzeit im Hintergrund

#define EN 5
#define RX 6
#define TX 7

#include <SoftwareSerial.h>     // die benötigte Bibliothek einbinden

SoftwareSerial esp8266(RX, TX); // an welchen Portpins soll RX und TX angeschlossen werden; erster zu übergebender Parameter ist RX, der zweite Parameter ist TX

char response[5];               // die antwort soll gespeichert werden, Annahme: 5 Byte reichen 
char c;                         // Laufvariable für array

 
void setup()
{
  pinMode(EN,OUTPUT);
  digitalWrite(EN,HIGH);
  Serial.begin(115200);         // Schnittstelle zum PC konfigurieren
  esp8266.begin(9600);        // Initialwert am ESP8266
                                // der erste Befehl soll nur prüfen, ob der ESP8266 reagiert
  esp8266.print("AT\r\n");      // die Zeichen müssen immer mit \r\n abgeschlossen werden <CR> + <LF>
  c=0;                          // fang bei 0 an zu zählen
  Serial.println("warte auf Antwort: ");
}

void loop() 
{
 esp8266.print("AT\r\n");      // die Zeichen müssen immer mit \r\n abgeschlossen werden <CR> + <LF>
  while (esp8266.available())     
  {
    response[c] = esp8266.read();
    Serial.print(c);Serial.print(' ');
    c++;
  }

}
