#define TEMP_IN  A0   //define analog pin1
#define LED 13        //define I/O pin13
#define sig_out 11    // Signalausgang an Pin D11
#define hyst 20       // mal zum probieren
#define T_on 500      // welche Freuqenz habe ich da eingestellt? hier 1kHz weil 2 x T_on = 1000 us was 1ms und damit ein kHz ergibt 
#define threshold 3.56 // Spannungswert der Schaltschwelle
#define warte1 500     // wartezeit um Schwellwert des ADC lesen zu können
#define warte_loop 200 // wartezeit bis zum nächsten Schleifendurchlauf


unsigned int val;       // aktueller ADC-Wert
unsigned int d_schwelle; // lege die Schaltschwelle als define fest
float v_grenzwert, v_volt;
boolean b_pieps;        // muss mir merken ob schon gepiepst wurde



void pieps(void);       // Funktion die nach loop definiert wird



void setup()
{
  pinMode(sig_out,OUTPUT);//set analog pin13 output
  Serial.begin(9600);//set baud rate 9600
  v_grenzwert=threshold * 1023 / 5; // umrechnung des Spannungswertes in den ADC-Wert
  d_schwelle = (unsigned int) v_grenzwert;
  b_pieps=0; // hat noch nicht gepiepst
  Serial.print("ADC-Grenzwert: ");Serial.print(v_grenzwert,2);Serial.print("ADC: ");Serial.print(d_schwelle,DEC);
  delay(2000);//wartezeit um den Wert auch lesen zu können
}


void loop()
{
   val = analogRead(TEMP_IN);//give the value of pin0 to val
   v_volt=val;
   v_volt=v_volt*5/1023;
   Serial.print("Spannung: "); Serial.println(v_volt,2);// gib nun die Variable 2-stellig aus
   if((val < d_schwelle) && (b_pieps == false)) // darf nut piepsen wenn Schwellwert unterschritten wird UND noch nicht gepiepst wurde
   {
     Serial.print("P I E P S ");
     pieps(); 
     b_pieps=true;
   }

   if(val > d_schwelle + hyst)
   { 
     digitalWrite(sig_out,LOW);
     b_pieps=false; // ab jetzt darf wieder gepiepst werden, wenn der Wert unterschritten wird
   }

}

void pieps(void)
{
  for(unsigned int x=0; x < 500; x++) // wenn Freuqenz 1000 Hz dann lasse 0.5s piepsen -> x=250; wenn x=500 dann piepst es eine Sekunde lang
  {
    digitalWrite(sig_out,HIGH);
    delayMicroseconds(T_on);
    digitalWrite(sig_out,LOW);
    delayMicroseconds(T_on);
  }  
}
