#define Echo 2  // Eingangspin für Empfangspuls
#define Trig 3  // Ausgang des Arduino Pin für den Auslöseimpuls
#define Ignore 200 // Entfernung ab der erst die Daten interessant werden, ignoriere größere Entfernungen
#define piepser 5  // wo ist der Buzzer angeschlossen
#define LED_rt 6   // wo ist die rote LED angeschlossen
#define LED_ge 7  //  welcher Pin stuert die gelbe LED
#define LED_gn 8  // wo ist die grüne LED angeschlossen
#define delta_led 300  // impulsweite [ms] !! für LED blinken

unsigned int delta_ton;  // bestimmt Tonfolgefrequenz [ms] !!
unsigned int Distanz;
boolean led_status,led_ge_status,led_rt_status;
boolean piep_status;// 
unsigned long timer_alt_ms, timer_akt_ms, timer_alt_us, timer_akt_us;// bruache zwei Timer einen millis() für LED blinken und einen micros() für Tonfrequenz


unsigned int measure(void);// diese funktion misst die Distanz und gibt einen floatwert zurück


void setup() 
{
  Serial.begin(9600);// BAUD rate festlegen
  Serial.println("Test: Init ports");
  pinMode(Trig,OUTPUT);
  digitalWrite(Trig,LOW);
  pinMode(piepser,OUTPUT);
  digitalWrite(piepser,LOW);
  pinMode(LED_rt,OUTPUT);
  digitalWrite(LED_rt,LOW);
  pinMode(LED_ge,OUTPUT);
  digitalWrite(LED_ge,LOW);
  pinMode(LED_gn,OUTPUT);
  digitalWrite(LED_gn,HIGH);
  pinMode(Echo,INPUT);
  Serial.println("Test: Ausgänge");
  delay(1000);// nur zum Test LED'S nacheinander einschalten
  digitalWrite(LED_ge,HIGH);
  delay(1000);
  digitalWrite(LED_rt,HIGH);
  delay(1000);
  digitalWrite(LED_rt,LOW);
  digitalWrite(LED_ge,LOW);// und wieder aus
  Serial.println("Test: Ton AN!");
  Distanz=measure();
  tone(piepser,2000,1000);// an welchem Pin, welche Frequenz [Hz] und dauer [ms] 
  timer_alt_ms = millis();
  led_status=HIGH;// grüne LED soll zunächst leuchten
  piep_status = LOW;
  led_ge_status = LOW;
  led_rt_status = LOW;
  Serial.println("Test: ENDE!");
  delta_ton=300;
}//****************** E N D   O F   S E T U P ******************************************
//######################################################################################


void loop() 
{
  do
  {  Distanz = measure(); }
  while(Distanz > 250); // wenn zwischendurch ein Wert mal zu groß ist
  Serial.print("enfernung: ");Serial.println(Distanz,DEC);// gib Wert über seriell aus
  
  if (Distanz < 10)
  {
    digitalWrite(LED_rt,HIGH);
    digitalWrite(LED_ge,LOW);
    digitalWrite(LED_gn,LOW);
    led_rt_status = HIGH;
    tone(piepser,2000);
  }
  
  else if((Distanz < 25) && ( led_rt_status == LOW))// hier brauche ich zwei timer
  {// der timer für den Ton erzeugt die Frequenz und der Timer millis() erzeugt die Pausen
   
    digitalWrite(LED_ge,HIGH);
    digitalWrite(LED_rt,LOW);
    digitalWrite(LED_gn,LOW);
    timer_akt_us = micros();
    timer_akt_ms = millis();
    led_ge_status = HIGH;
    if((timer_alt_ms + delta_ton) < timer_akt_ms)// wenn die Zeit delta_led verstrichen ist
    {
      // led_status != led_status; // wenn led_Status == 1 war wird er 0 und umgekehrt
       if (led_status == LOW)
        { led_status = HIGH;delta_ton=300;} 
      else 
        {led_status = LOW;delta_ton=700;}
      timer_alt_ms = millis();  // led_status bestimmt hier, ob pieps_Ton ein oder pieps_Ton aus ist
    }
    if(led_status)
      { tone(piepser,2000);}
    else
    { noTone(piepser); }
    
  }

  else if ((Distanz < 50) && (led_ge_status == LOW))// &&  (led_ge_status == LOW) )// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  {
    noTone(piepser);// falls zuvor irgendwo eingeschaltet
    digitalWrite(LED_gn,led_status);
    digitalWrite(LED_ge,LOW);
    digitalWrite(LED_rt,LOW);
    timer_akt_ms = millis();
    if((timer_alt_ms + delta_led) < timer_akt_ms)// wenn die Zeit delta_led verstrichen ist
    {
      //led_status != led_status; // wenn led_Status == 1 war wird er 0 und umgekehrt
      if (led_status == LOW)
        { led_status = HIGH;} 
      else 
        {led_status = LOW;}
      timer_alt_ms = millis();
    }
  }

  else if(Distanz > 50) // wenn distanz größer dann soll grüne LED dauerhaft leuchten
  { 
    noTone(piepser);// falls zuvor irgendwo eingeschaltet
    digitalWrite(LED_gn,HIGH);
    digitalWrite(LED_rt,LOW);
    digitalWrite(LED_ge,LOW);
    digitalWrite(piepser,LOW);
    led_ge_status = LOW;// irgendwo muss der status ja wieder gelöscht werden
    led_rt_status = LOW;
  }
}//*********  E N D  O F   L O O P  *******************##########################
//###############################################################################



unsigned int measure(void)
{
  float val;
  unsigned int val2;
  digitalWrite(Trig,HIGH);
  delayMicroseconds(10);// löse den Sendeimpuls aus
  digitalWrite(Trig,LOW);
  val2 = pulseIn(Echo,HIGH);// Zähle so lange die Zeit bis ein HIGH-Puls am Eingang ECHO erkannt wird 
  val = val2/2;// der Impuls legt die Strecke vom und zum Objekt zurück
  val = val * 340 * 0.0001; // Schallausbreitungsgeschwindigkeit ist bei Raumtemperatur 340m/s = 34000cm/s = 0.034cm/us
  val2=(unsigned int)floor(Distanz);// floor rundet eine float zahl ab
  return val;
}
