#define Echo 2
#define Trig 3

#define piepser 5
#define LED_rt 6
#define LED_ge 7
#define LED_gn 8

#define delta_led 300  // impulsweite [ms] !! für LED blinken
#define delta_ton 250  // bestimmt Tonfrequenz [us] !!

unsigned int Distanz;
boolean led_status,led_ge_status,led_rt_status;
boolean piep_status;// 
unsigned long timer_alt_ms, timer_akt_ms, timer_alt_us, timer_akt_us;// bruache zwei Timer einen millis() für LED blinken und einen micros() für Tonfrequenz

unsigned int measure(void);// diese funktion misst die Distanz und gibt einen floatwert zurück

void setup() {
  Serial.begin(9600);
  Serial.println("Test: Init ports");
  pinMode(Trig,OUTPUT);
  digitalWrite(Trig,LOW);
  pinMode(piepser,OUTPUT);
  digitalWrite(piepser,LOW);
  pinMode(LED_rt,OUTPUT);
  digitalWrite(LED_rt,LOW);
  pinMode(LED_ge,OUTPUT);
  digitalWrite(LED_ge,LOW);
  pinMode(LED_gn,OUTPUT);
  digitalWrite(LED_gn,HIGH);
  pinMode(Echo,INPUT);
  Serial.println("Test: Ausgänge");
  delay(1000);// nur zum Test LED'S nacheinander einschalten
  digitalWrite(LED_ge,HIGH);
  delay(1000);
  digitalWrite(LED_rt,HIGH);
  delay(1000);
  digitalWrite(LED_rt,LOW);
  digitalWrite(LED_ge,LOW);// und wieder aus
  Serial.println("Test: Ton AN!");
  Distanz=measure();
  
  Distanz=0;// habe keine andere Variable und wollte keine extra anlegen
  do
  {
    delayMicroseconds(delta_ton);
    digitalWrite(piepser,HIGH);
    delayMicroseconds(delta_ton);
    digitalWrite(piepser,LOW);
    Distanz++;
  }
  while(Distanz < 2000); // eine Sekunde solls piesen
  
  timer_alt_ms = millis();
  
  led_status=HIGH;// grüne LED soll zunächst leuchten
  piep_status = LOW;
  led_ge_status = LOW;
  led_rt_status = LOW;
  Serial.println("Test: ENDE!");
}//****************** E N D   O F   S E T U P ****************************


void loop() 
{
  do
  {  Distanz = measure(); }
  while(Distanz > 250); // wenn zwischendurch ein Wert mal zu groß ist
  Serial.print("enfernung: ");Serial.println(Distanz,DEC);// gib Wert über seriell aus
  
  if (Distanz < 10)
  {
    if( led_rt_status)
    {
      digitalWrite(LED_rt,HIGH);
      digitalWrite(LED_ge,LOW);
      digitalWrite(LED_gn,LOW);
    }
    led_rt_status = HIGH;
    delayMicroseconds(delta_ton);
    digitalWrite(piepser,HIGH);
    delayMicroseconds(delta_ton);
    digitalWrite(piepser,LOW);
  }
 
  else if(Distanz > 10) // wenn distanz größer dann soll grüne LED dauerhaft leuchten
  { 
    
    digitalWrite(LED_gn,HIGH);
    digitalWrite(LED_rt,LOW);
    digitalWrite(LED_ge,LOW);
    digitalWrite(piepser,LOW);
    led_ge_status = LOW;// irgendwo muss der status ja wieder gelöscht werden
    led_rt_status = LOW;
  }
}//*********  E N D  O F   L O O P  *******************




unsigned int measure(void)
{
  float val;
  unsigned int val2;
  digitalWrite(Trig,HIGH);
  delayMicroseconds(10);// löse den Sendeimpuls aus
  digitalWrite(Trig,LOW);
  val2 = pulseIn(Echo,HIGH);// Zähle so lange die Zeit bis ein HIGH-Puls am Eingang ECHO erkannt wird 
  val = val2/2;// der Impuls legt die Strecke vom und zum Objekt zurück
  val = val * 340 * 0.0001; // Schallausbreitungsgeschwindigkeit ist bei Raumtemperatur 340m/s = 34000cm/s = 0.034cm/us
  val2=(unsigned int)floor(Distanz);// floor rundet eine float zahl ab
  return val;
}
