#define Echo 3    // eingangssignal des Ultraschallsensord
#define Trig 2    // für Startimpuls des Ultraschallsensors
#define Taster 10 // Taster für Aufnahme
#define Rec 6     // Signal zur Aufnahme
#define Play 8    // Signal zum Starten der Wiedergabe
#define max_time 6000 // maximal erlaubte Laufzeit s = v * t -> t = s / v; ->   t = 2 * 100cm Hühe / 0.034[cm / us] die Entfernung muss doppelt gezählt werden: Hin und zurück
#define Schwelle 50  // unter 50 cm soll die Wiedergabe starten
#define Spielzeit 10000 // maximale Zeit für Aufnahme


int Duration;
int warte;
float Distanz;
unsigned long timer_akt, timer_old;

void trigger(void); // diese funktion schaltet den Trigger kurz auf high
void measure(void); // messe ob jemand anwesend ist


void setup() 
{
  // put your setup code here, to run once:
  pinMode(Echo, INPUT);
  pinMode(Trig, OUTPUT);
  digitalWrite(Trig,LOW);
  pinMode(Taster, INPUT_PULLUP);
  pinMode(Rec,OUTPUT);
  digitalWrite(Rec,LOW);
  pinMode(Play,OUTPUT);
  digitalWrite(Play,LOW);
}

void loop() 
{
  // put your main code here, to run repeatedly:
  measure(); // messe die Entfernung
  if(Distanz == 0)
  {} // keine Person erkannt
  else if(Distanz < Schwelle)
  {
    digitalWrite(Play,HIGH);
    delay(100);
    digitalWrite(Play,LOW);
  }
 if(digitalRead(Taster) == LOW) //  ist Taste gedrückt? 
 {
  delay(20);
  timer_old=millis();
  if(digitalRead(Taster) == LOW) //  wenn Taste immer noch gedrückt -> starte Aufnahem
  {
    digitalWrite(Rec,HIGH);
    do
    {
      timer_akt=millis();
      warte=timer_akt - timer_old; // wie lange ist die Taste scho gedrückt?
    }
    while(( warte < Spielzeit) && ((digitalRead(Taster)) == LOW ));// 
    digitalWrite(Rec,LOW); // wenn aufnahmezeit verstrichen, oder wenn Taste losgelassen, dann beende Aufnahme
  }
 }
}

void measure(void)
{
  trigger();
  Duration = pulseIn(Echo,HIGH,max_time); // Zähle so lange die Zeit bis ein HIGH-Puls am Eingang ECHO erkannt wird, Falls keiner erkannt wird breche nach 12ms Wartezeit ab
  Distanz = Duration/2;               // der Impuls legt die Strecke vom und zum Objekt zurück
  Distanz = Distanz * 0.0340;         // Schallausbreitungsgeschwindigkeit ist bei Raumtemperatur 340m/s = 34000cm/s = 0.034cm/us
}


void trigger(void)
{
  digitalWrite(Trig,HIGH);
  delayMicroseconds(10);// löse den Sendeimpuls aus
  digitalWrite(Trig,LOW);
}
