#include <LiquidCrystal.h>
#include <Wire.h>
#include <RTClib.h>


PCF8563 rtc;  // Objekt erstellen
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);

int x = 0;
int minute = 1;
int hour = 12;
int sec = 0;
int am = 0; //1 = morning
bool up = false;
bool down = false;
bool display_update = true;
bool amtopm = false;
int backled = 9;
int button = 13;
int val = 0;
int aState;
int aLastState;
bool aktuell;


void setup() 
{
    aktuell=1;
    if(aktuell == 0)
    {
 // bitte hier das gewünschte Datum und die Uhrzeit eingeben: Jahr, Monat, Tag, Stunde, Minute, Sekunde) Reihenfolge beachten!!
    rtc.adjust(DateTime(2021, 12, 29, 14, 8, 20)); // Zeile nur zum Setzen der Uhrzeit einkommentieren
    }
    else
    {
    Serial.println("aktuelles");
    Serial.println("Datum  und Uhrzeit:");
    DateTime now = rtc.now();
    Serial.print(now.day(), DEC);
    Serial.print('/');
    Serial.print(now.month(), DEC);
    Serial.print('/');
    Serial.print(now.year(), DEC);
    Serial.print(" ");
    Serial.print(now.hour(), DEC);
    Serial.print(':');
    Serial.print(now.minute(), DEC);
    Serial.print(':');
    Serial.print(now.second(), DEC);
    Serial.println();
    hour=now.hour();
    minute=now.minute();
    sec=0;
    }
  pinMode(button, INPUT);
  pinMode(A2, INPUT);
  pinMode(A3, INPUT);
  // pinMode(13, OUTPUT);
  pinMode(backled, OUTPUT);
  analogWrite(backled, 255);
  // set up the LCD’s number of columns and rows:
  lcd.begin(16, 2);
  lcd.setCursor(3, 0);
  lcd.print("Uhrzeit:");

  //set timer1 interrupt at 1Hz
  TCCR1A = 0;// set entire TCCR1A register to 0
  TCCR1B = 0;// same for TCCR1B
  TCNT1 = 0;//initialize counter value to 0
  // set compare match register for 1hz increments
  OCR1A = 15624;// = (16*10^6) / (1*1024) – 1 (must be <65536)
  // turn on CTC mode
  TCCR1B |= (1 << WGM12);
  // Set CS10 and CS12 bits for 1024 prescaler
  TCCR1B |= (1 << CS12) | (1 << CS10);
  // enable timer compare interrupt
  TIMSK1 |= (1 << OCIE1A);
  sei();//allow interrupts
}

void display() 
{
  if(hour >= 10) 
  {
    lcd.setCursor(3, 2);
    lcd.print(hour);
  } 
  else 
  {
    lcd.setCursor(3, 2);
    lcd.print('0');
    lcd.setCursor(4, 2);
    lcd.print(hour);
  }

  lcd.setCursor(5, 2);
  lcd.print(':');

  if(minute >= 10) 
  {
    lcd.setCursor(6, 2);
    lcd.print(minute);
  } 
  else 
  {
    lcd.setCursor(6, 2);
    lcd.print('0');
    lcd.setCursor(7, 2);
    lcd.print(minute);
  }

  lcd.setCursor(8, 2);
  lcd.print(':');
  if(sec >= 10)
  {
    lcd.setCursor(9, 2);
    lcd.print(sec); 
  } 
  else 
  {
    lcd.setCursor(9, 2);
    lcd.print('0');
    lcd.setCursor(10, 2);
    lcd.print(sec);
  }
  if(am == 1)
  {
    lcd.setCursor(12, 2);
    lcd.print("am");
  } 
  else 
  {
    lcd.setCursor(12, 2);
    lcd.print("pm");
  }
}

void counting_time()
{
  if(minute < 0 ) 
  { 
    minute = 59;
    hour=hour-1;
  }
  if(hour < 1)
  {  hour = 12; } 
  
  if (sec >= 60)
  {
    sec = 0;
    minute++;
  }

  if (minute >= 60)
  {
    hour++;
    minute = 0;
  }
  
  if (hour >=13) 
  { hour = 1;  }
  
  if(hour == 12 && minute == 0)
  { // to make sure only 1 am to pm transition
    if(amtopm == true) 
    {
      amtopm = false;
      if(am == 1)
      {
        am = 0;
      } 
      else 
      {
        am = 1;
      }
    }
  }
  else
  { 
    amtopm = true;
  }
}


ISR(TIMER1_COMPA_vect)
{//timer1 interrupt 1Hz
  sec++;
  counting_time();
  if(display_update) 
  {
    display();
  }
}

void loop() 
{
  val = digitalRead(button); // read button
  if (val == HIGH) 
  {
  //lcd.setCursor(0, 0);
  //lcd.print(“o”);
  //minute++;
  //delay(500);
  }

  aState = digitalRead(A3);
  if (aState != aLastState)
  {
  // If the outputB state is different to the outputA state, that means the encoder is rotating clockwise
  if (digitalRead(A2) != aState) 
  {
    display_update = false;
    minute ++;
    counting_time();
    if(minute >= 10) 
    {
      lcd.setCursor(3, 2);
      lcd.print(minute);
    } 
    else 
    {
      lcd.setCursor(3, 2);
      lcd.print('0');
      lcd.setCursor(4, 2);
      lcd.print(minute);
    }
    display_update = true;
  } 
  else 
  {
    display_update = false;
    minute=minute-1;
    counting_time();
    if(minute >= 10) 
    {
      lcd.setCursor(3, 2);
      lcd.print(minute);
    } 
    else 
    {
      lcd.setCursor(3, 2);
      lcd.print('0');
      lcd.setCursor(4, 2);
      lcd.print(minute);
    }
    display_update = true;
  }
  }
  aLastState = aState; //
}
