#include <LiquidCrystal.h>

#define clk1_pin 13  
#define clk2_pin 12  
#define sw_pin 8
#define short_press 300
#define long_press 1000

LiquidCrystal lcd(2, 3, 4, 5, 6, 7);

boolean dir;
int last;  
int act;
enum { s_min, s_hour, s_opt };

unsigned char x_pos_h,x_pos_m,h_pos,m_pos;
unsigned char option;
unsigned int d;
unsigned long start;
unsigned long led_start;
unsigned long timer_akt;
unsigned long timer_old;
boolean Anz12_24;
boolean changed;

unsigned char h, m, s;

void zeige_uhrzeit(void); // gibt die aktuellen Werte auf dem Display aus
void tastendruck(void);   // wurde taste betätigt und losgeleassen

void setup() {
  Serial.begin(115200);
  pinMode(clk1_pin,INPUT_PULLUP);
  pinMode(clk2_pin,INPUT_PULLUP);
  pinMode(sw_pin,INPUT_PULLUP);
  
  lcd.begin(16, 2);
  lcd.setCursor(3, 0);
  lcd.print("Uhrzeit:");

  h=10;
  m=0;
  s=0;
  last=digitalRead(clk1_pin);
  option=s_min; //zuerst soll Minute geändert werden
}

void loop() 
{
  // put your main code here, to run repeatedly:
  // Ändere die aktuelle Uhrzeit
  // ist Taste gedrückt?
  timer_akt=0;
  d=digitalRead(sw_pin);
  if(d==0)
    { tastendruck(); }
  if((timer_akt < short_press) && (timer_akt != 0))
  { 
     changed=0; 
     Serial.println("sw betätigt");
     timer_akt=0;     // damit di eBedingung bei der nächsten Abfrage schon erfüllt ist, auch ohne erneuten Tastendruck
     do
     {     
        Serial.print('a');delay(50);
        // werte evtl. die Drehbewegung aus
        act = digitalRead(clk1_pin);
        // Überprüfung auf Änderung
        if ((act != last) && (act == 0))
        { 
          Serial.print('b');
          delay(2);//zum Entprellen, aber man darf nicht zu schnell drehen
          if (digitalRead(clk2_pin) != act) // clk1_pin hat sich zuerst verändert: cw
            { dir = true;   Serial.print('c');} 
          else                              // Andernfalls hat sich clk2_pin zuerst verändert: CCW
            { dir = false;  Serial.print('d');}
         
          if (dir)//erniedrige die Werte
          { 
            
            Serial.println ("cw"); 
            if(option == s_min)
            { m++; }
            
            if(option == s_hour)
            { h++; }
            
            zeige_uhrzeit();
            if(option == s_opt)
            {
               Serial.print('e');
              if(Anz12_24)  // wenn 0 dann 12h wenn 1 dann 24h
              {
                Anz12_24=0;
                lcd.setCursor(14, 2);
                lcd.print("12h");
              }
              else
              {
                Anz12_24=1;
                lcd.setCursor(14, 2);
                lcd.print("24h");
              }
          }
          else // erhöhe die Werte
            { 
              Serial.println("ccw"); 
              if(option == s_min)
                { m--; Serial.print('f'); }
                
              if(option == s_hour)
                { h--; Serial.print('g');}
              zeige_uhrzeit();
              if(option == s_opt)
              {
                 Serial.print('h');
                if(Anz12_24)  // wenn 0 dann 12h wenn 1 dann 24h
                {
                  Anz12_24=0;
                  lcd.setCursor(13, 2);
                  lcd.print("12h");
                }
                else
                {
                  Anz12_24=1;
                  lcd.setCursor(13, 2);
                  lcd.print("24h");
                }//ende else
              }//ende if(option == s_opt)
            }//ende  else // erhöhe die Werte
        } // ende  if (dir)//erniedrige die Werte
        last = act;// aktueller Status ist alter Wert
        // werte shortpress aus
        // longpress ist exit
        if(timer_akt > long_press)
        {
           Serial.print('i');
          //exit:
          changed=1;
        }
        
        if((timer_akt < short_press) && (timer_akt != 0))
        {
           Serial.print('k');
          // nächste Stelle min -> stunde -> option:12h/24h -> min -> ... nächster Abfragestatus
          if(option < 2)
            { option++; }
          else
           { option=0; }
          Serial.print("opt: ");Serial.println(option,DEC);
        }
      }// ende if ((act != last) && (act == 0)) 
        
     }
     while(!changed);// so lange nicht geändert, bleibe in der Schleife
     delay(70); // Entprellzeit, könnte vielleicht auch kürzer sein?
  }

// ermittle die aktuelle Uhrzeit
  timer_akt=millis();

  if(timer_akt > timer_old+1000)
  { 
   uhrzeit();
  }
  
  
  
}
//ende von loop ##################################################################
//################################################################# ###############

void uhrzeit(void)
{
  



void tastendruck(void)
{
   d=digitalRead(sw_pin);
   if(d == 0)// wenn ja, dann ändere die Uhrzeit
   {
      timer_old=millis();
      delay(20);//entprellen
      d=digitalRead(sw_pin);
      if(d == 0)// wenn ja, dann ändere die Uhrzeit
      {
        do // warte bis Taste wieder losgelassen
         {  d=digitalRead(sw_pin);   }
        while(d == 0);
       }
      timer_akt=millis();
      timer_akt = timer_akt - timer_old;
      Serial.print("dauer: ");Serial.println(timer_akt,DEC);       
    } 
}

void zeige_uhrzeit(void)
{
  //#########################################################
//zeige die aktuelle Uhrzeit im LCD Display
 if(h >= 10) 
  {
    x_pos_h=3;
    h_pos=3;
    lcd.setCursor(h_pos, 2);
    lcd.print(h);
  } 
  else 
  {
    x_pos_h=4;
    h_pos=4;
    lcd.setCursor(3, 2);
    lcd.print('0');
    lcd.setCursor(h_pos, 2);
    lcd.print(h);
  }

  lcd.setCursor(5, 2);
  lcd.print(':');

  if(m >= 10) 
  {
    x_pos_m=6;
    m_pos=6;
    lcd.setCursor(m_pos, 2);
    lcd.print(m);
  } 
  else 
  {
    x_pos_m=7;
    m_pos=7;
    lcd.setCursor(6, 2);
    lcd.print('0');
    lcd.setCursor(m_pos, 2);
    lcd.print(m);
  }

  lcd.setCursor(8, 2);
  lcd.print(':');
  if(s >= 10)
  {
    lcd.setCursor(9, 2);
    lcd.print(s); 
  } 
  else 
  {
    lcd.setCursor(9, 2);
    lcd.print('0');
    lcd.setCursor(10, 2);
    lcd.print(s);
  }
}
