#include <LiquidCrystal.h>

#define clk1_pin 13  
#define clk2_pin 12  
#define sw_pin 8
#define short_press 300
#define long_press 500
  

LiquidCrystal lcd(2, 3, 4, 5, 6, 7);

boolean dir;
int last;  
int act;
enum { s_hour, s_min, s_opt };

unsigned char x_pos_h,x_pos_m,h_pos,m_pos;
unsigned char option;
unsigned char limit;
unsigned int d;
unsigned long start;
unsigned long led_start;
unsigned long timer_akt,timer_old,t_akt,t_old;
boolean Anz12_24;
boolean changed;
boolean displayed;

unsigned char h, m, s;

void zeige_uhrzeit(void); // gibt die aktuellen Werte auf dem Display aus
void tastendruck(void);   // wurde taste betätigt und losgeleassen
void uhrzeit(void);//berechne uhrzeit


void setup() 
{
  Serial.begin(115200);
  pinMode(clk1_pin,INPUT_PULLUP);
  pinMode(clk2_pin,INPUT_PULLUP);
  pinMode(sw_pin,INPUT_PULLUP);
  
  lcd.begin(16, 2);
  lcd.setCursor(3, 0);
  lcd.print("Uhrzeit:");

  h=10;
  m=0;
  s=0;
  last=digitalRead(clk1_pin);
  option=s_hour; //zuerst soll Minute geändert werden
  timer_old=millis();
  displayed=0; // damit nicht bei jedem Drehimpuls das LCD Display angesteuert werden muss sondern nur einmal
}

void loop() 
{
  // put your main code here, to run repeatedly:
  // Ändere die aktuelle Uhrzeit
  // ist Taste gedrückt?
  t_akt=0;
  d=digitalRead(sw_pin);
  if(d==0)
    { tastendruck(); }
  if((t_akt < short_press) && (t_akt != 0))
  { 
     changed=0; 
     Serial.println("sw betätigt");
     t_akt=0;     // damit di eBedingung bei der nächsten Abfrage schon erfüllt ist, auch ohne erneuten Tastendruck
     do
     {     
        act = digitalRead(clk1_pin);
        // Überprüfung auf Änderung
        if((option == s_hour) && (displayed == 0))
        {
          lcd.setCursor(3, 0);
          lcd.print("Stunden:");
          displayed=1;// merke mir, dass die aktuelle Überschrift im LCD jetzt steht
        }
        if((option == s_min) && (displayed == 0))
        {
          lcd.setCursor(3, 0);
          lcd.print("Minuten:");
          displayed=1;// merke mir, dass die aktuelle Überschrift im LCD jetzt steht
        }
        if((option == s_opt) && (displayed == 0))
        {
          lcd.setCursor(3, 0);
          if(Anz12_24)
            {lcd.print("24h:"); }
          else
            { lcd.print("12h:");}
          lcd.print("change?");
          displayed=1;// merke mir, dass die aktuelle Überschrift im LCD jetzt steht
        }
        
        delay(2);
        if ((act != last) && (act == 0))//darf nur eine Flanke auswerten sonst zählt der doppelt
        { 
          if (digitalRead(clk2_pin) != act) // clk1_pin hat sich zuerst verändert
             { dir = true; } 
          else  // Andernfalls hat sich clk2_pin zuerst verändert
             { dir = false; }
           
          if (dir)//erniedrige die Werte
          { 
            
            Serial.print("cw: ");Serial.println(option,DEC);
            if(option == s_min)
            { 
              if( m < 59)
                { m++; }
              else
                { m=0; }   
            }
            
            if(option == s_hour)
            { 
              if(Anz12_24 == 0)
                { limit=12;}
              else
                { limit=24; }

              if(h < limit)
                { h++; }
              else
                { h=1; } 
              if(h == 24)
                { h=0;} // soll 0 uhr statt 24 Uhr anzeigen
            }
            
            zeige_uhrzeit();
            if(option == s_opt)
            {
              
              if(Anz12_24)  // wenn 0 dann 12h wenn 1 dann 24h
              {
                Anz12_24=0;
                lcd.setCursor(13, 2);
                lcd.print("12h");
              }
              else
              {
                Anz12_24=1;
                lcd.setCursor(13, 2);
                lcd.print("24h");
              }
            }
          } 
          else // erhöhe die Werte
          { 
              Serial.print("ccw ");Serial.println(option,DEC); 
              if(option == s_min)
                { 
                  if(m > 0)
                    { m--; }
                  else
                    { m=0; }  
                }
                
              if(option == s_hour)
                { 
                  if(h > 0)
                    { h--; }
                  else
                    { h=0; } 
                }
              zeige_uhrzeit();
              if(option == s_opt)
              {
                 
                if(Anz12_24)  // wenn 0 dann 12h wenn 1 dann 24h
                {
                  Anz12_24=0;
                  lcd.setCursor(13, 2);
                  lcd.print("12h");
                }
                else
                {
                  Anz12_24=1;
                  lcd.setCursor(13, 2);
                  lcd.print("24h");
                }//ende else
              }//ende if(option == s_opt)
            }//ende  else // erhöhe die Werte
        } // ende  if (dir)//erniedrige die Werte
      // Vorbereitung für den nächsten Druchlauf:
      // Der Wert des aktuellen Durchlaufs ist beim nächsten Druchlauf der vorherige Wert
      last = act;
      // Reset-Funktion um aktuelle Position zu speichern
      d=digitalRead(sw_pin);
      if(d==0)
          { tastendruck(); }
      // Vorbereitung für den nächsten Druchlauf:
      // Der Wert des aktuellen Durchlaufs ist beim nächsten Druchlauf der vorherige Wert
      last = act;
      // Reset-Funktion um aktuelle Position zu speichern
      // werte shortpress aus
      // longpress ist exit
      if(t_akt > long_press)
      {
         Serial.print('i');
         //exit:
         changed=1;
      }
      if((t_akt < short_press) && (t_akt != 0))
      {
           Serial.print('k');
          // nächste Stelle min -> stunde -> option:12h/24h -> min -> ... nächster Abfragestatus
          if(option < 2)
            { option++; }
          else
           { option=0; }
          Serial.print("opt: ");Serial.println(option,DEC);
          t_akt=0;// sonst laufe ich immer in diese Abfrage
          displayed=0;// jetzt soll die Überschrift im LCD aktualisiert werden
      }      
      
    }
    while(!changed);// so lange nicht geändert, bleibe in der Schleife
    lcd.clear();// damit die option 12h / 24h gelöscht wird
    lcd.setCursor(3, 0);
    lcd.print("Uhrzeit:");
    zeige_uhrzeit();
    delay(70); // Entprellzeit, könnte vielleicht auch kürzer sein?
   
  }    
 // ermittle die aktuelle Uhrzeit
 timer_akt=millis();
 if(timer_akt > timer_old+1000)
   { uhrzeit(); }
}
//ende von loop ##################################################################
//################################################################################
void uhrzeit(void)
{
  s++;
  timer_old=timer_akt;
  
  if (s >= 60)
  {
    s = 0;
    m++;
  }
  
  if (m >= 60)
  {
    m = 0;
    h++;
  }
  if((Anz12_24 == 0) && (h >= 13))
  {
    h = 1;
  }
  
  if((Anz12_24 == 1) && (h >= 24))
  {
    h = 0;
  }
  zeige_uhrzeit();
}

void tastendruck(void)
{
   d=digitalRead(sw_pin);
   if(d == 0)// wenn ja, dann ändere die Uhrzeit
   {
      t_old=millis();
      delay(20);//entprellen
      d=digitalRead(sw_pin);
      if(d == 0)// wenn ja, dann ändere die Uhrzeit
      {
        do // warte bis Taste wieder losgelassen
         {  d=digitalRead(sw_pin);   }
        while(d == 0);
       }
      t_akt=millis();
      t_akt = t_akt - t_old;
      Serial.print("dauer: ");Serial.println(t_akt,DEC);       
    } 
}

void zeige_uhrzeit(void)
{
  //#########################################################
//zeige die aktuelle Uhrzeit im LCD Display
 if(h >= 10) 
  {
    x_pos_h=3;
    h_pos=3;
    lcd.setCursor(h_pos, 2);
    lcd.print(h);
  } 
  else 
  {
    x_pos_h=4;
    h_pos=4;
    lcd.setCursor(3, 2);
    lcd.print('0');
    lcd.setCursor(h_pos, 2);
    lcd.print(h);
  }

  lcd.setCursor(5, 2);
  lcd.print(':');

  if(m >= 10) 
  {
    x_pos_m=6;
    m_pos=6;
    lcd.setCursor(m_pos, 2);
    lcd.print(m);
  } 
  else 
  {
    x_pos_m=7;
    m_pos=7;
    lcd.setCursor(6, 2);
    lcd.print('0');
    lcd.setCursor(m_pos, 2);
    lcd.print(m);
  }

  lcd.setCursor(8, 2);
  lcd.print(':');
  if(s >= 10)
  {
    lcd.setCursor(9, 2);
    lcd.print(s); 
  } 
  else 
  {
    lcd.setCursor(9, 2);
    lcd.print('0');
    lcd.setCursor(10, 2);
    lcd.print(s);
  }
}  
