// In diesem Beispiel wird die Helligkeit mit dem 
// Potentiometer an A0 verändert


// lege die Portleitungen fest:
#define LED_data 2 // mit Pin 16 von BLINK! verbunden
#define LED_clk  3 // mit Pin 18 von BLINK! verbunden
//               +5V  mit PIN4 von BLINK! verbunden
//                GND mit PIN6 von BLINK! verbunden
// lege die Wartezeiten der Schaltzustände fest
#define warte_EIN 800
#define warte_AUS 400
#define ADC PIN_A0
//##########################

// definiere die Variablen
byte v_brightness; // Wert für die Helligkeit
unsigned int poti;
//#########################

// Funktionsprototypen:
void spiWrite(byte LEDs);
//#########################


void setup() 
{

  pinMode(LED_data,OUTPUT);  
  pinMode(LED_clk,OUTPUT); 
  Serial.begin(9600);
}

//#####################################

void loop()
{
  poti=analogRead(ADC); // dieser Wert ist 10 Bit lang
  poti >>= 5;           // jetzt wurden unteren  5 Bit abgeschnitten
  v_brightness= (byte) poti;// integer Variable in 5 Bit Variable umwandeln
  v_brightness = v_brightness | 0b11100000; // die ersten drei Bit auf HIGH setzen
  Serial.println(v_brightness,BIN);
  // Start Frame: 32 Bit 0
  spiWrite(0x00);   
  spiWrite(0x00);
  spiWrite(0x00);
  spiWrite(0x00);

  // LED1 frame: Weiss mit weniger Helligket
  spiWrite(v_brightness);   // brighntness: Bi4 ... Bit0
  spiWrite(0b11111111);   // blaue LED EIN
  spiWrite(0b11111111);   // grüne LED: EIN
  spiWrite(0b11111111);   // rote LED: EIN

  // LED2 frame: ROT  
  spiWrite(v_brightness);   // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);   // blaue LED: AUS
  spiWrite(0b00000000);   // green LED OFF
  spiWrite(0b11111111);   // rote LED: EIN

  // LED3 frame:  Grün
  spiWrite(v_brightness);   // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);   // blaue LED: AUS
  spiWrite(0b11111111);   // grüne LED: EIN
  spiWrite(0b00000000);   // rote LED: AUS

  // LED4 frame: BLAU
  spiWrite(v_brightness);   // brighntness: Bi4 ... Bit0
  spiWrite(0b11111111);   // blaue LED EIN
  spiWrite(0b00000000);   // green LED OFF
  spiWrite(0b00000000);   // rote LED: AUS

  // LED5 frame: gelb
  spiWrite(v_brightness);   // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);   // blaue LED: AUS
  spiWrite(0b11111111);   // grüne LED: EIN
  spiWrite(0b11111111);   // rote LED: EIN

  // LED6 frame: Türkis
  spiWrite(v_brightness);   // brighntness: Bi4 ... Bit0
  spiWrite(0b11111111);   // blaue LED EIN
  spiWrite(0b11111111);   // grüne LED: EIN
  spiWrite(0b00000000);   // rote LED: AUS

  // LED7 frame: Magenta 
  spiWrite(v_brightness);   // brighntness: Bi4 ... Bit0
  spiWrite(0b11111111);   // blaue LED EIN
  spiWrite(0b00000000);   // green LED OFF
  spiWrite(0b11111111);   // rote LED: EIN
  
  // LED8 frame: Weiss
  spiWrite(v_brightness);   // brighntness: Bi4 ... Bit0
  spiWrite(0b11111111);   // blaue LED EIN
  spiWrite(0b11111111);   // grüne LED: EIN
  spiWrite(0b11111111);   // rote LED: EIN

  // ENDE FRAME: 32 Bit auf high
  spiWrite(0b11111111);   
  spiWrite(0b11111111);  
  spiWrite(0b11111111);  
  spiWrite(0b11111111);  
   
  delay(warte_EIN);

  // AllE LEDs wieder auf AUS:  
  // Start Frame 
  spiWrite(0x00);
  spiWrite(0x00);
  spiWrite(0x00);
  spiWrite(0x00);

  //LED1 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED2 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED3 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED4 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED5 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED6 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED7 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

 //LED8 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS
  
  spiWrite(0b11111111);   
  spiWrite(0b11111111);   
  spiWrite(0b11111111);   
  spiWrite(0b11111111);   
   
  // Alle LEDs sind aus
  delay(warte_AUS);
}
//##################################################################################################################################################


void spiWrite(byte LEDs) // gib ein Datenbyte aus
{
  uint8_t i;
  for (i=0; i<8 ;i++)
  {
    if (LEDs&0x80)   // schaue, ob das Datenbit HIGH ist
      { digitalWrite(LED_data, HIGH);   } 
    else 
    {  digitalWrite(LED_data, LOW);   }     
    // erzeuge nun das CLK Signal, damit das Datenbit vom Empfänger eingelesen wird  
    digitalWrite(LED_clk, HIGH);
    delayMicroseconds(1);
    digitalWrite(LED_clk, LOW);
    delayMicroseconds(1);
    LEDs <<= 1; // einmal links schieben und nächstes MSB Bit prüfen
  }
 digitalWrite(LED_data, HIGH);
}
