
// In diesem Beispiel wird die Anzahl der angestuerten LEDs mit dem 
// Potentiometer an A0 verändert


// lege die Portleitungen fest:
#define LED_data 2 // mit Pin 16 von BLINK! verbunden
#define LED_clk  3 // mit Pin 18 von BLINK! verbunden
//               +5V  mit PIN4 von BLINK! verbunden
//                GND mit PIN6 von BLINK! verbunden
// lege die Wartezeiten der Schaltzustände fest
#define warte_EIN 800
#define warte_AUS 400
#define ADC PIN_A0
#define global 0b11101000  // ist der erste Frame bei der datenübertragung
//##########################

// definiere die Variablen
byte v_brightness;  // Wert für die Helligkeit
byte v_global;      // erstes Byte im Datenframe
unsigned int poti;
uint8_t i;          // Laufvariable für for-Schleife
uint8_t anzahl;     // wie viele LEDs sollen leuchten anzahl: 1 ... 8
uint8_t bl_anteil, gn_anteil, rt_anteil;

//#########################

// Funktionsprototypen:
void spiWrite(byte LEDs);
//#########################


void setup() 
{

  pinMode(LED_data,OUTPUT);  
  pinMode(LED_clk,OUTPUT); 
  Serial.begin(9600);
}

//#####################################

void loop()
{
  v_brightness=0b00001000;  // halbe Helligkeit
  v_global= global | v_brightness;
  // lege die gewünschte Farbe fest
  bl_anteil=0;
  rt_anteil=255;
  gn_anteil=0;
  
  poti=analogRead(ADC); // dieser Wert ist 10 Bit lang
  anzahl=map(poti, 0,1023,1,8); // die Eingangsdaten des ADC (0 ... 1023) umwandeln in Anzahl gewünschter LEDs
 
  // Start Frame: 32 Bit 0
  spiWrite(0x00);   
  spiWrite(0x00);
  spiWrite(0x00);
  spiWrite(0x00);

  for(i=0; i < anzahl; i++)
  {
    spiWrite(v_global);       // brighntness: Bi4 ... Bit0
    spiWrite(bl_anteil);   // blaue LED EIN
    spiWrite(gn_anteil);   // grüne LED: EIN
    spiWrite(rt_anteil);   // rote LED: EIN
  }

  // ENDE FRAME: 32 Bit auf high
  spiWrite(0b11111111);   
  spiWrite(0b11111111);  
  spiWrite(0b11111111);  
  spiWrite(0b11111111);  
   
  delay(warte_EIN);

  // AllE LEDs wieder auf AUS:  
  // Start Frame 
  spiWrite(0x00);
  spiWrite(0x00);
  spiWrite(0x00);
  spiWrite(0x00);

  //LED1 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED2 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED3 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED4 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED5 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED6 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

  //LED7 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS

 //LED8 frame
  spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
  spiWrite(0b00000000);  // blaue LED: AUS
  spiWrite(0b00000000);  // green LED OFF
  spiWrite(0b00000000);  // rote LED: AUS
  
  spiWrite(0b11111111);   
  spiWrite(0b11111111);   
  spiWrite(0b11111111);   
  spiWrite(0b11111111);   
   
  // Alle LEDs sind aus
  //delay(warte_AUS);
}
//##################################################################################################################################################


void spiWrite(byte LEDs) // gib ein Datenbyte aus
{
  uint8_t i;
  for (i=0; i<8 ;i++)
  {
    if (LEDs&0x80)   // schaue, ob das Datenbit HIGH ist
      { digitalWrite(LED_data, HIGH);   } 
    else 
    {  digitalWrite(LED_data, LOW);   }     
    // erzeuge nun das CLK Signal, damit das Datenbit vom Empfänger eingelesen wird  
    digitalWrite(LED_clk, HIGH);
    delayMicroseconds(1);
    digitalWrite(LED_clk, LOW);
    delayMicroseconds(1);
    LEDs <<= 1; // einmal links schieben und nächstes MSB Bit prüfen
  }
 digitalWrite(LED_data, HIGH);
}
