// In diesem Beispiel wird die Anzahl der angestuerten LEDs mit dem 
// Potentiometer an A0 verändert
// Der Schönheitsfehler im Beispiel LED_Blink_BSP3.ino war, dass immer die letzte LED weiss geblinkt hat
// daraufhin wurd Zeile 126, 127, 128, 148, 149 und 150 auskommentiert
// als weitere Aufgabe wird gefordert, dass die LEDs nur erneut angesteuert werden, wenn der Wert: anzahl sich verändert

// NEU;
// die Funktion constrain beschränkt eine Variable auf einen definierten Zahlenbereich
// dies ist hier von Nuzen, weil beim Poti auf endanschlag der Wert sehr schwankt


// lege die Portleitungen fest:
#define LED_data 2 // mit Pin 16 von BLINK! verbunden
#define LED_clk  3 // mit Pin 18 von BLINK! verbunden
//               +5V  mit PIN4 von BLINK! verbunden
//                GND mit PIN6 von BLINK! verbunden
// lege die Wartezeiten der Schaltzustände fest
#define warte_EIN 800
#define warte_AUS 400
#define ADC PIN_A0
#define global 0b11101000  // ist der erste Frame bei der datenübertragung
//##########################

// definiere die Variablen
byte v_brightness;  // Wert für die Helligkeit
byte v_global;      // erstes Byte im Datenframe
unsigned int poti;
uint8_t i;          // Laufvariable für for-Schleife
uint8_t anzahl,anzahl_alt;     // wie viele LEDs sollen leuchten anzahl: 1 ... 8
uint8_t bl_anteil, gn_anteil, rt_anteil;

//#########################

// Funktionsprototypen:
void spiWrite(byte LEDs);
//#########################


void setup() 
{

  pinMode(LED_data,OUTPUT);  
  pinMode(LED_clk,OUTPUT); 
  Serial.begin(9600);
  anzahl_alt=0;
}

//#####################################

void loop()
{
  v_brightness=0b00001000;  // halbe Helligkeit
  v_global= global | v_brightness;
  // lege die gewünschte Farbe fest
  bl_anteil=0;
  rt_anteil=255;
  gn_anteil=0;
  
  poti=analogRead(ADC); // dieser Wert ist 10 Bit lang
  poti=constrain(poti,0,1010);  // begrenze den Wert auf ein defniertes Maximum
  
  // wenn die LEDs alle aus sein sollen, beim Minimalwert:
  anzahl = map(poti, 0,1010,0,8); // die Eingangsdaten des poti (0 ... 1010) umwandeln in Anzahl gewünschter LEDs
  // wenn die erste LED beim Minimalwert noch leuchten soll:
  //anzahl=map(poti, 0,1010,1,8); // die Eingangsdaten des poti (0 ... 1010) umwandeln in Anzahl gewünschter LEDs
  
  if(anzahl != anzahl_alt)
  {
    Serial.print(poti,DEC);Serial.print("  ");Serial.println(anzahl,DEC);
    // zuerst alle AllE LEDs wieder auf AUS:  
    // Start Frame 
    spiWrite(0x00);
    spiWrite(0x00);
    spiWrite(0x00);
    spiWrite(0x00);

    //LED1 frame
    spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
    spiWrite(0b00000000);  // blaue LED: AUS
    spiWrite(0b00000000);  // green LED OFF
    spiWrite(0b00000000);  // rote LED: AUS

    //LED2 frame
    spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
    spiWrite(0b00000000);  // blaue LED: AUS
    spiWrite(0b00000000);  // green LED OFF
    spiWrite(0b00000000);  // rote LED: AUS

    //LED3 frame
    spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
    spiWrite(0b00000000);  // blaue LED: AUS
    spiWrite(0b00000000);  // green LED OFF
    spiWrite(0b00000000);  // rote LED: AUS

    //LED4 frame
    spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
    spiWrite(0b00000000);  // blaue LED: AUS
    spiWrite(0b00000000);  // green LED OFF
    spiWrite(0b00000000);  // rote LED: AUS

    //LED5 frame
    spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
    spiWrite(0b00000000);  // blaue LED: AUS
    spiWrite(0b00000000);  // green LED OFF
    spiWrite(0b00000000);  // rote LED: AUS

    //LED6 frame
    spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
    spiWrite(0b00000000);  // blaue LED: AUS
    spiWrite(0b00000000);  // green LED OFF
    spiWrite(0b00000000);  // rote LED: AUS

    //LED7 frame
    spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
    spiWrite(0b00000000);  // blaue LED: AUS
    spiWrite(0b00000000);  // green LED OFF
    spiWrite(0b00000000);  // rote LED: AUS

  //LED8 frame
    spiWrite(0b11100000);  // brighntness: Bi4 ... Bit0
    spiWrite(0b00000000);  // blaue LED: AUS
    spiWrite(0b00000000);  // green LED OFF
    spiWrite(0b00000000);  // rote LED: AUS
  
    spiWrite(0b11111111);   
    //spiWrite(0b11111111);   
    //spiWrite(0b11111111);   
    //spiWrite(0b11111111);   
   
    // Alle LEDs sind aus
    //delay(warte_AUS);
    // Start Frame: 32 Bit 0
    spiWrite(0x00);   
    spiWrite(0x00);
    spiWrite(0x00);
    spiWrite(0x00);

    for(i=0; i < anzahl; i++)
    {
      spiWrite(v_global);       // brighntness: Bi4 ... Bit0
      spiWrite(bl_anteil);   // blaue LED EIN
      spiWrite(gn_anteil);   // grüne LED: EIN
      spiWrite(rt_anteil);   // rote LED: EIN
    }

    // ENDE FRAME: 32 Bit auf high
    spiWrite(0b11111111);   
    //spiWrite(0b11111111);  
    //spiWrite(0b11111111);  
    //  spiWrite(0b11111111);  
    anzahl_alt=anzahl;
  }// ende von if
  
}
//##################################################################################################################################################


void spiWrite(byte LEDs) // gib ein Datenbyte aus
{
  uint8_t i;
  for (i=0; i<8 ;i++)
  {
    if (LEDs&0x80)   // schaue, ob das Datenbit HIGH ist
      { digitalWrite(LED_data, HIGH);   } 
    else 
    {  digitalWrite(LED_data, LOW);   }     
    // erzeuge nun das CLK Signal, damit das Datenbit vom Empfänger eingelesen wird  
    digitalWrite(LED_clk, HIGH);
    delayMicroseconds(1);
    digitalWrite(LED_clk, LOW);
    delayMicroseconds(1);
    LEDs <<= 1; // einmal links schieben und nächstes MSB Bit prüfen
  }
 digitalWrite(LED_data, HIGH);
}
