#define LED_neg1 13
#define LED_neg0 12
#define LED_mid 8
#define LED_pos0 6
#define LED_pos1 11
  
#include <Wire.h>
 
//Variables for Gyroscope
int gyro_x, gyro_y, gyro_z;
 
float acc_x, acc_y, acc_z,acc_y_alt,middle;
 
// Setup timers and temp variables
long loop_timer;
float temp;

void init_MPU6050(void); 
void read_MPU6050(void);
 
void setup() {
 
  //Start I2C
  Wire.begin();
 
  // Set Level LEDs as outputs
  pinMode(LED_neg1, OUTPUT);
  pinMode(LED_neg0, OUTPUT);
  pinMode(LED_mid, OUTPUT);
  pinMode(LED_pos0, OUTPUT);
  pinMode(LED_pos1, OUTPUT);
  
  
  //Setup the registers of the MPU-6050                                                       
  init_MPU6050(); 

  // Start Serial Monitor                                                 
  Serial.begin(115200);
  read_MPU6050();
  acc_y_alt = acc_y;            
  // bilde einen Mittelwert über 1000 Werte
  for(int x=0; x < 1000; x++)
  {
    acc_y=(acc_y+acc_y_alt)/2;
    acc_y_alt=acc_y;  
    delay(2);                     
  }
  middle=acc_y;
  delay(1000);// warte ein wenig
 // bilde noch einmal einen Mittelwert über 1000 Werte 
  for(int x=0; x < 1000; x++)
  {
    acc_y=(acc_y+acc_y_alt)/2;
    acc_y_alt=acc_y;  
    delay(2);                     
  }
  middle = (acc_y + middle)/2;// Mitlerwert der Mittelwerte errechnen
}
 
void loop(){
 
  // Get data from MPU-6050
    read_MPU6050();
    acc_y=(acc_y+acc_y_alt)/2;
    acc_y_alt=acc_y;
    acc_y = acc_y - middle;
    
    acc_y = acc_y / 16;  // damit die Zahl nicht zu groß wird teile durch 16, ohne mathematische Herleitung
    if (acc_y < -2.01) {
    // Turn on Level LED
    digitalWrite(LED_neg1, HIGH);
    digitalWrite(LED_neg0, LOW);
    digitalWrite(LED_mid, LOW);
    digitalWrite(LED_pos0, LOW);
    digitalWrite(LED_pos1, LOW);
    
    } else if ((acc_y > -2.00) && (acc_y < -1)) {
    // Turn on Level LED
    digitalWrite(LED_neg1, LOW);
    digitalWrite(LED_neg0, HIGH);
    digitalWrite(LED_mid, LOW);
    digitalWrite(LED_pos0, LOW);
    digitalWrite(LED_pos1, LOW);
    
    } else if ((acc_y < 1.00) && (acc_y >= -1.00)) {
    // Turn on Level LED
    digitalWrite(LED_neg1, LOW);
    digitalWrite(LED_neg0, LOW);
    digitalWrite(LED_mid, HIGH);
    digitalWrite(LED_pos0, LOW);
    digitalWrite(LED_pos1, LOW);
    
    } else if ((acc_y >= 1.0) && (acc_y < 2.00)) {
    // Turn on Level LED
    digitalWrite(LED_neg1, LOW);
    digitalWrite(LED_neg0, LOW);
    digitalWrite(LED_mid, LOW);
    digitalWrite(LED_pos0, HIGH);
    digitalWrite(LED_pos1, LOW);
    
    } else if (acc_y > 2.01) {
    // Turn on Level LED
    digitalWrite(LED_neg1, LOW);
    digitalWrite(LED_neg0, LOW);
    digitalWrite(LED_mid, LOW);
    digitalWrite(LED_pos0, LOW);
    digitalWrite(LED_pos1, HIGH);
    
    }
    Serial.println(acc_y);
    delay(100);
  
  
  
 
 
  
}
 
void init_MPU6050(void)
{
 // reset the sensor
  Wire.beginTransmission(0x68); //Start communicating with the MPU-6050
  Wire.write(0x6B);  //Send the requested starting register            
  Wire.write(0x00);//Set the requested starting register     
  Wire.endTransmission();//End the transmission        
                                              
  //Configure the accelerometer ±2g (00), ±4g (01), ±8g (10), ±16g (11)
  Wire.beginTransmission(0x68);  //Start communicating with the MPU-6050
  Wire.write(0x1C);   //Send the requested starting register            
  Wire.write(0x10); //Set the requested starting register            
  Wire.endTransmission(); //End the transmission        
                                              
  //Configure the gyro full scale : 00 = ±250dps 01= ±500dps 10 = ±1000dps 11 = ±2000dps
  Wire.beginTransmission(0x68);//Start communicating with the MPU-6050
  Wire.write(0x1B);//Send the requested starting register
  Wire.write(0x08); //Set the requested starting register     
  Wire.endTransmission(); //End the transmission           
                                              
}
 
 
void read_MPU6050(void)
{ 
  Wire.beginTransmission(0x68);  //Start communicating with the MPU-6050             
  Wire.write(0x3B);//Send the requested starting register    
  Wire.endTransmission(); //End the transmission   
  Wire.requestFrom(0x68,14); //order 14 bytes from the MPU-6050     
  while(Wire.available() < 14);//Wait until all the bytes are received        
                
  acc_x = Wire.read()<<8|Wire.read();   // store in integer                               
  acc_y = Wire.read()<<8|Wire.read();                                  
  acc_z = Wire.read()<<8|Wire.read();                                  
  temp = Wire.read()<<8|Wire.read();                                   
  gyro_x = Wire.read()<<8|Wire.read();                                 
  gyro_y = Wire.read()<<8|Wire.read();                                 
  gyro_z = Wire.read()<<8|Wire.read();  

  temp=temp/340+36.5; // is from the example code from joy-it
  // show now the raw data of the sensor:     
  Serial.print("Beschleunigung: ");Serial.print(acc_z,DEC);Serial.print(" | ");Serial.print(acc_y,DEC);Serial.print(" | ");Serial.println(acc_x,DEC);
  Serial.print("Kreisel-Wert: ");Serial.print(gyro_z,DEC);Serial.print(" | ");Serial.print(gyro_y,DEC);Serial.print(" | ");Serial.print(gyro_x,DEC);
  Serial.print(" Temp im Sensor : ");Serial.println(temp,DEC);  
                            
}
