#include "Wire.h" 
#define MPU6050_ADDR 0x68 // wenn AD0 -> HIGH  --> Addresse = 0x69

unsigned int accX, accY, accZ;

char text[7]; // 

void setup() {
  Serial.begin(9600);
  Wire.begin();
  Wire.beginTransmission(MPU6050_ADDR);
  Wire.write(0x6B); // dies ist das Powermanagement 1 register
  Wire.write(0); // es wird u.a. sleep = 0 -> wake up und interner 8Mhz oscillator == ein 
  Wire.endTransmission(true);// TRUE beendet die Datenübertragung
}
void loop() {
  Wire.beginTransmission(MPU6050_ADDR);
  Wire.write(0x3B); // starting with register 0x3B (ACCEL_XOUT_H)
  Wire.endTransmission(false); // die Datenübertragung ist beendet, der Kanal bleibt aber aktiv
  Wire.requestFrom(MPU6050_ADDR, 6, true); // anforderung von 6 registerwerten
  // "Wire.read()<<8 | Wire.read();" means two registers are read and stored in the same int16_t variable
  accX = Wire.read()<<8 | Wire.read(); // register 0x3B (ACCEL_X_OUT_High) und 0x3C (ACCEL_X_OUT_Low)  -> accX
  accY = Wire.read()<<8 | Wire.read(); // register 0x3D (ACCEL_Y_OUT_High) und 0x3E (ACCEL_Y_OUT_Low)  -> accY
  accZ = Wire.read()<<8 | Wire.read(); // register 0x3F (ACCEL_Z_OUT_High) und 0x40 (ACCEL_Z_OUT_Low)  -> accZ
 
  
  Serial.print(" x = "); Serial.print(accX,DEC);
  Serial.print(" y = "); Serial.print(accY,DEC);
  Serial.print(" z = "); Serial.print(accZ,DEC);
  Serial.println();
  delay(500);
}


  
