#define limit_O 200
#define limit_U 10
#define PIR 3         // Ausgang des PIR-sensors
#define LED1 7        // Ausgangspin des Arduino zum Schalten der LED
#define t_LED 900     // wie viele ms soll die Anteige-LED ein sein?
#define t_debounce 20 // Zeit zum "Entprellen" der Taste
//              ende der defines                                #####################
//###################################################################################


unsigned int count;   // Ereigniszahler
boolean v_flanke;     // variable für Zustand des Eingangssignals 
// ende der Variablendeklarationen
//####################################################################################


void warte_flanke(boolean status_flanke);
// ende der Deklaration der Funktionsprototypen
//####################################################################################


void setup() 
{
  pinMode(LED1, OUTPUT);    // LED ist OUTPUT
  pinMode(PIR, INPUT);      // PIR-Signal als INPUT schalten, um einzulesen
  Serial.begin(9600);       // Innitialisiere die serielle Schnittstelle mit 9600 Baud
  count=0;                  // variable =0 weil noch kein Gast gezählt wurde
}
// ende von s e t u p ();   ###########################################################
//#####################################################################################


void loop() 
{ 
  warte_flanke(HIGH);        // warte auf ein HIGH-Signal des Sensors 
  digitalWrite(LED1, HIGH);  // signalisiere die Anwesenheit mit LED einschalten
  warte_flanke(LOW);         // warte bis der Sensor bereit ist für die nächste Person
  digitalWrite(LED1, LOW);   // LED abschalten
  count++; // wenn jemand erkannt wurde, dann erhohe um 1
  Serial.print(" bisher gezaehlt: ");
  Serial.println(count,DEC); 
}
//#######################################################################################
// ende von l o o p ();  ################################################################
//#######################################################################################

void warte_flanke(boolean status_flanke)
{
  boolean in;                                               // Status des eingelesenen Pin
  if(status_flanke == LOW)
  {
    do
    {
      in=digitalRead(PIR);
      delay(t_debounce);              // wartezeit zum "Entprellen"
      if(in == LOW)
        { v_flanke=digitalRead(PIR); }
    }
    while(v_flanke);// wenn PIR auslöst, ist v_flanke == 0 und damit die abbruchbedingung erfüllt 
  }

  if(status_flanke == HIGH)
  {
    do
     {
      in=digitalRead(PIR);
      delay(t_debounce);
      if(in == HIGH)
        { v_flanke=digitalRead(PIR); }            // wenn in immer noch HIGH, dann 
     }
    while(!v_flanke);//Abbruchbedingung ist wenn der Wert zwischen der Klammer == 0, also falsch ist; 
    //durch ! wird v_flanke negiert und muss für den Abbruch deshalb HIGH werden
  }
}

// ende der Funktion  warte_flanke();#################################################
//####################################################################################
