


#define LED 13              // Definiere den LED Pin
#define schwelle 1000       // lege die Schaltschwelle fest
#define OnTimer 500         // wie lange soll die LED leuchten
#define motor 3             // Pin fuer PWM-Ausgabe
#define irq_pin 2           // Eingangspin fuer Interrupt des Speedsensors
#define poti_pin A0         // Eingang fuer Potentiometer

// Benoetigte Variable:
int intervall, anzahl, counter;
long wait, old_micros, usInterval, old_millis, akt_millis;;
unsigned int poti, alt_poti;          // integer Variable für den AD-Wandler  

void count(void);
void output(void);

void setup() 
{
  intervall=2; // wie viele Sekunden werden die Impulse gezaehlt
  wait = intervall * 1000;// in Millisekunden umrechnen
  // put your setup code here, to run once:
  counter = 0; // counter auf 0 setzen
  anzahl = 20; // Loecher in der Encoder-Scheibe
  anzahl = anzahl * 2; // Anzahl der Loecher in der Encoder-Scheibe mit 2
  pinMode(irq_pin, INPUT); // Setzen des analogen Pins als Input
  attachInterrupt(digitalPinToInterrupt(irq_pin), count, CHANGE); // zwei Pulse je Loch
  pinMode(LED,OUTPUT);      // Ausgänge initialisieren
  pinMode(motor,OUTPUT);
  Serial.begin(115200);     // Baudrate festlegen
  old_millis=millis();
  alt_poti=analogRead(poti_pin);
  alt_poti=alt_poti/4;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//##################################################################################
void loop() 
{
  // put your main code here, to run repeatedly:
  counter=0; // auf 0 zuruecksetzen  
  do
  {
    poti=analogRead(poti_pin);// lese poti =  0 ... 1024
    poti = poti /4;           // PWM Wert liegt zwischen 0 ... 255
    analogWrite(3, poti);     // an den Pins 3, 5, 6, 9, 10, 11 ist die PWM verfügbar
    akt_millis=millis();
    if((poti > (alt_poti+10)) || (poti < (alt_poti-10)))      // hat sich der Poti Wert verändert, dann gib den aktuellen Wert aus
    {
      Serial.print("Poti: ");Serial.println(poti,DEC); // gib den aktuellen PWM-Wert aus
      alt_poti=poti;
    }  
  }
  while(akt_millis < (old_millis + wait)); // wenn die Zeit verstrichen ist, dann Schleife verlassen  

  Serial.print("Poti: ");Serial.println(poti,DEC); // gib den aktuellen PWM-Wert aus  
  Serial.print("count ");Serial.println(counter,DEC); // gib den aktuellen PWM-Wert aus
  counter = counter / anzahl;  // dividiert durch Anzahl der Löcher in der Scheibe
  counter = counter / intervall;// wie lange wird gemessen -> umrechnen auf Impulse pro Sekunde
  counter = counter * 60; // auf eine Minute hochrechnen
  Serial.print("Drehzahl: ");Serial.println(counter,DEC); // gib den aktuellen PWM-Wert aus
 
}
//----------------------------------------------------------------------------

// Zaehlt Loecher der Encoder-Scheibe (mit Filter)
void count(void)
{
 if (micros() - old_micros >= 700)
{
 counter++;
 old_micros = micros();
 }
}
