// mit diesem Beispiel soll gezeigt werden,
// wie eine LED  durch eine PWM
// gedimmt wird. Dazu dient der Befehl analogWrite( char );
// dabei wird der Funktion analogWrite eine Variable vom Typ char [0 ... 255] übergeben
//                                                              0: Ausgang ist auf low
                                                       //     127: Ausgang ist 50% der Zeit low und 50% der Zeit High; Tastverhältnis also 1:1
                                                       //     255: Ausgang ist auf High, die LED leuchtet mit voller Intensität 


#define ledPin 11  // LED an PWM Pin anschließen 
#define delta_t 25 // wie lange soll der aktuelle Wert gültig dein
#define delta_val 5// um wie viel soll der Wert bei jedem Durchlauf geändert werden

unsigned char val; // val ist 0 ... 255, deshalb als char definiert

void setup() 
{
  pinMode(ledPin, OUTPUT);
}

void loop() 
{
  // in dieser for-Schleife wird die LED mit jedem Durchlauf heller 
  for (val = 0 ; val <= 255; val += delta_val) 
  {
    analogWrite(ledPin, val);
    delay(delta_t);
  }

  // in dieser for-Schleife wird die LED mit jedem Durchlauf wieder dunkler 
  for (int fadeValue = 255 ; fadeValue >= 0; fadeValue -= delta_val) 
  {
     analogWrite(ledPin, fadeValue);
     delay(delta_t);
  }
}
