// ausgabe der Uhrzeit in zwei Zeilen oben links die Stunden
// unten rechts die Minuten
#define dataPin 3
#define clkPin 2

unsigned char digit[8]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
unsigned char data[11]={0x03,0x9F, 0x25, 0x0D, 0x99, 0x49, 0x41, 0x1F, 0x01, 0x09, 0xFE};   
unsigned char dig_active[8]={0,0,0,0,0,0,0,0};// es können nur maximal acht digit 1.. 8 aktiv sein, wenn 0xA dann aus ansonsten 0 ... 9 und B für Dot
unsigned char x;
unsigned char timer;  // dieser Wert ist abhängig von der Anzahl der verwendeten Zeichen
                        // je mehr Zeichen desto kleiner soll die Zeit sein um flackern zu verhindern
                        // aber je größer die Zeit, desto heller die Anzeige
unsigned char h, m, s, h1, h2, m1, m2;
boolean Anz12_24;

unsigned long t_old, t_now;

void setup() {
  Serial.begin(9600);
  // notwendige Pins als Ausgang definieren
  pinMode(dataPin,OUTPUT);
  pinMode(clkPin, OUTPUT);

  h = 12; // Startzeit Stunden
  m = 0;  // Startzeit Minuten
  s = 0;  // Startzeit Sekunden
  
  Anz12_24=1; //0:12h  1: 24h Darstellung
  timer=3; 
  t_old=millis();
}

void loop() {
  // put your main code here, to run repeatedly:


  t_now=millis();
  if(t_now > t_old+ 1000)  // t_now+t_old > 1000 ist immer der Fall
  {
    s++;
    t_old=t_now;
  }


 // Serial.print("H: "); Serial.print(h1,DEC); Serial.print(h2,DEC); Serial.print(" min: "); Serial.print(m1,DEC); Serial.print(m2,DEC); Serial.print(" sec: "); Serial.println(s,DEC); 
  if (s >= 60)
  {
    s = 0;
    m++;
  }
  if (m >= 60)
  {
    m = 0;
    h++;
  }
  if((Anz12_24 == 0) && (h >= 13))
  {
    h = 1;
  }
  
  if((Anz12_24 == 1) && (h >= 24))
  {
    h = 0;
  }
  //Ganze zahl
  h1=h / 10; // Zehnerstelle_Stunde
  // Rest
  h2=h % 10; // Einerstelle_Stunde
  // ganze Zahl
  m1=m /10;  // Zehnerstelle_Minute
  // Rest
  m2=m % 10; // Einerstelle_Minute


  dig_active[0]= data[h1]; // erstes Digit bekommt Zehner-Stelle der Stunden
  dig_active[1]= data[h2]; // zweites Digit bekommt Einer-Stelle der Stunden
  dig_active[6]= data[m1]; // siebtes Digit bekommt Zehner-Stelle der Minuten
  dig_active[7]= data[m2]; // achtes Digit bekommt Einer-Stelle der Minuten 
  
  for(x=0; x <= 7; x++)
  {
    if(dig_active[x] !=0)
    {
      shiftOut(dataPin, clkPin, LSBFIRST, dig_active[x]); // Ziffer 0
      shiftOut(dataPin, clkPin, LSBFIRST, digit[x]);// erstes Digit
      delay(timer);
    }
  }
}
