#define dataPin 3
#define clkPin 2

unsigned char digit[9]={0,0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
unsigned char data[12]={0x03,0x9F, 0x25, 0x0D, 0x99, 0x49, 0x41, 0x1F, 0x01, 0x09, 0xFE, 0xFD}; //0 1 2 3 4 5 6 7 8 9 0 . -   
unsigned char dig_active[8]={0,0,0,0,0,0,0,0};// es können nur maximal acht digit 1.. 8 aktiv sein, wenn 0xA dann aus ansonsten 0 ... 9 und B für Dot
unsigned char x;
unsigned char half;
unsigned char timer;  // dieser Wert ist abhängig von der Anzahl der verwendeten Zeichen
                        // je mehr Zeichen desto kleiner soll die Zeit sein um flackern zu verhindern
                        // aber je größer die Zeit, desto heller die Anzeige
unsigned char h, m, s, h1, h2, m1, m2;
boolean Anz12_24;

unsigned long t_old, t_now;

void setup() {
  Serial.begin(9600);
  // notwendige Pins als Ausgang definieren
  pinMode(dataPin,OUTPUT);
  pinMode(clkPin, OUTPUT);

  h = 12; // Startzeit Stunden
  m = 0;  // Startzeit Minuten
  s = 0;  // Startzeit Sekunden
  
  Anz12_24=1; //0:12h  1: 24h Darstellung
  timer=3; 
  t_old=millis();
  half=0;
}

void loop() {
  // put your main code here, to run repeatedly:

  
  t_now=millis();
  if(t_now > t_old+ 500)  // t_now+t_old > 1000 ist immer der Fall
  {
    dig_active[3]= data[11];
    dig_active[4]= data[11];
    dig_active[5]= data[11];
    dig_active[6]= data[11];
    half++;
    t_old=t_now;
    if(half ==2)
    {
      s++;
      half=0;
      dig_active[3]= data[10];
      dig_active[4]= data[10];
      dig_active[5]= data[10];
      dig_active[6]= data[10];
    }
  }
 
  
  Serial.print("H: "); Serial.print(h1,DEC); Serial.print(h2,DEC); Serial.print(" min: "); Serial.print(m1,DEC); Serial.print(m2,DEC); Serial.print(" sec: "); Serial.println(s,DEC); //verzögert den Durchlauf und somit ist letzte Ziffer deutlich heller
  if (s >= 60)
  {
    s = 0;
    m++;
  }
  if (m >= 60)
  {
    m = 0;
    h++;
  }
  if((Anz12_24 == 0) && (h >= 13))
  {
    h = 1;
  }
  
  if((Anz12_24 == 1) && (h >= 24))
  {
    h = 0;
  }
  //Ganze zahl
  h1=h / 10; // Zenerstelle_Stunde
  // Rest
  h2=h % 10; // Einerstelle_Stunde
  // ganze Zahl
  m1=m /10;  // Zenerstelle_Minute
  // Rest
  m2=m % 10; // Einerstelle_Minute


  dig_active[1]= data[h1]; // 
  dig_active[2]= data[h2]; // 
  dig_active[7]= data[m1]; // 
  dig_active[8]= data[m2]; // 
  
  for(x=1; x <= 8; x++)
  {
    if(dig_active[x] !=0)
    {
      shiftOut(dataPin, clkPin, LSBFIRST, dig_active[x]); // Ziffer 0
      shiftOut(dataPin, clkPin, LSBFIRST, digit[x]);// erstes Digit
      delay(timer);
    }
  }
}
