// Transistor T soll Last einschalten
// Timer soll aus sleep wecken damit Powerbank geschont wird 
// aber sie muss so belastet werden, dass sie nict abschaltet
// wie groß muss der Strom sein
// wie lang darf die PAuse sein
// Widerstand mit 47R probieren


#include "LowPower.h"//muss zuerst vom internet geholt werden dann als zip eingebunden !!!!!
#include <EEPROM.h>


// D E F I N E S : *************************************************************************
#define addr 0x01 // Wert für die Adresse im EEPROM kann 0 ... 0xFF bzw. 0 ... 254 sein
#define T 6      // hier ist die Basis des Transistors angeschlossen
#define T_on  100 // einschalzeit für Lastwiderstand
#define LED 4     // Anzeige-LED
#define BAUD 9600 // Übertagungsrate
#define Hysterese 20 // damit die LED nicht bei jeder kleinen Schwankung schaltet, 
//                      definiert man eine Hysterese

// Variablendeklarationen: *********************************************
unsigned int licht, s;
unsigned int val;
boolean schreib;
unsigned char data;
boolean powerbank;


// FUNKTIONS D E K L A R A T I O N:  ***********************************
void Verbraucher_ein(void);



// the setup function runs once when you press reset or power the board
void setup() 
{
  // initialize digital pin LED_BUILTIN as an output.
  pinMode(LED, OUTPUT);
  pinMode(T,OUTPUT); //mit einem Transistor an Pin D10 kann man einen Strom fließen lassen um 
                     // ein abschalten der Powerbank zu verhindern 
  val=0;
  Serial.begin(BAUD);
  EEPROM.write(addr, val);// jetzt steht die 0 im EEPROM
  schreib =0;
  s=500; //Schwellwert für die Dunkelheit, Wert wurde beliebig gewählt
  powerbank=1; // bei Betterieberieb ist powerbank = 0;
}



// the loop function runs over and over again forever
void loop() 
{
  licht = analogRead(A0);
  Serial.println(licht,DEC);
  if(powerbank)
  { Verbraucher_ein();} // nach dem aufwachen, soll sofort mehr Strom gezogen werden, aber nicht bei Batteriebetrieb
                    
  if(licht <  s) 
  { // wenn Licht erkannt wird, wird gespeichert
    val++;//immer wenn ich Licht bekomme, erhöhe ich den Wert
    EEPROM.write(addr, val);
    schreib = 1;
  }

  if(licht > s)// wenn es wieder dunkel ist mache ich Falle scharf
    { schreib=0; }

  if(Serial.available())// habe ich Daten vom PC empfangen
  {// wenn daten empfangen werden, führe den gewünschten Befehl aus 
    do
    {
      data = Serial.read();
      if(data == 'r')
        {
        val=EEPROM.read(addr);
        Serial.print(val,DEC);
        }
      if(data == 'l');
        { 
          val=0;// setze den Wert wieder auf Null
          EEPROM.write(addr,val);  
        }
    }
    while(Serial.available());
  }

  // mit diesem Befehl geht der Arduino für die Dauer von 8s schlafen
  LowPower.idle(SLEEP_8S, ADC_OFF, TIMER2_OFF, TIMER1_OFF, TIMER0_OFF, SPI_OFF, USART0_OFF, TWI_OFF);

}


void Verbraucher_ein(void)
{
  digitalWrite(T,HIGH);// Last einschalten
  delay(T_on);
  digitalWrite(T,LOW);// Last wieder ausschalten
}
