 
#define mess_in A0
#define power_IR 7

// die Formel ist Verschmutzung = Spannung * 0,172 - 0.1
// Werte für die Verschmutzung
// > 2500      =  sehr schlechte Luft
// 1000 ... 2500: schlechte Luft
// 300 ... 1000:  erträglich
// 150 ... 300 :  gute Luft
// 75 ... 150 : sehr gute Luft
// < 75 : äußerst gute Luftqualität

float v_A0 = 0;
float v_spannung_A0 = 0;
float Staubdichte = 0;
  
void setup(){
  Serial.begin(9600);
  pinMode(power_IR,OUTPUT);
 
}
  
void loop()
{
  digitalWrite(power_IR,LOW);// alle 10ms soll gemessen werden
  delayMicroseconds(280);   // dabei soll die LED ca. 300us EIN sein
 
  v_A0 = analogRead(mess_in);// lese den ADC-Wert
 
  delayMicroseconds(40);
  digitalWrite(power_IR,HIGH);
  delayMicroseconds(9680);
 
  v_spannung_A0 = v_A0*(5.0/1024);// wandle den ADC in einen Spannungswert um
  Staubdichte = 0.172*v_spannung_A0-0.1;// Bestimme den Verschmutzungsgrad an Hand der gemessenen Spannung
 
  if ( Staubdichte < 0)
  {
    Staubdichte = 0.00;
  }
  
  Serial.println("Raw Signal Value (0-1023):");
  Serial.println(v_A0);
 
  Serial.println("Voltage:");
  Serial.println(v_spannung_A0);
 
  Serial.println("Dust Density:");
  Serial.println(Staubdichte);
   
 
  delay(1000);
}
