#define S0 2
#define S1 3
#define S2 4
#define S3 5
#define sensorOut 6
#define LED_rt 7
#define LED_gn 8
#define LED_bl 9
#define BAUD 9600
// end of #defines  #########################
//###########################################

int fqu_rot, fqu_grn, fqu_blau;// Variable für Frequenzwerte
int rot_gerundet, grn_gerundet, blau_gerundet;// alle gemappten Werte
int MIN_ROT, MAX_ROT, MIN_GRN, MAX_GRN, MIN_BLAU, MAX_BLAU;// Werte aus der KAlibrierung
int color = 0;
// ende der Variablenfestlegungen
//################################################

void bestimme_Farbe(void);// aus den vorgegebenen Grenzwerten können Farbwerte festgelegt werden
void sag_Farbe(void); // gib die Farbwerte und damit festgelegten Farben aus 
void lese_frequenzen(void);// Lese die Frequenzwerte der Farben 

void setup() 
{
 //Initialisiere Ausgänge
 pinMode(S0, OUTPUT);
 pinMode(S1, OUTPUT);
 pinMode(S2, OUTPUT);
 pinMode(S3, OUTPUT);
 pinMode(LED_rt, OUTPUT);
 pinMode(LED_gn, OUTPUT);
 pinMode(LED_bl, OUTPUT);
 pinMode(sensorOut, INPUT);
 // Setze frequency scaling auf 20%:
 digitalWrite(S0,HIGH);
 digitalWrite(S1,LOW);
 Serial.begin(BAUD);//öffne die serielle Schnittstelle
 //Kalibrierung();//Kalibrierung sensor (look at serial monitor)
}

void loop() 
{
 lese_frequenzen();//read sensor
 delay(800);
 bestimme_Farbe();//format color values
 sag_Farbe();//print values
}

void bestimme_Farbe() 
{
 

 //gib die Werte als PWM auf eine RGB-LED
 analogWrite(LED_rt, fqu_rot);
 analogWrite(LED_gn, fqu_grn);
 analogWrite(LED_bl, fqu_blau);
 //nun lege die Farbe fest, aufgrund der gemessenen und gerundeten Werte: 
if ((fqu_rot > 24) && (fqu_rot < 30) && (fqu_grn > 80) && (fqu_grn < 95) && (fqu_blau > 75) && (fqu_blau < 85)) 
  { color = 4;} //definiert Farbe: rot
 
 else if ((fqu_rot > 93) && (fqu_rot < 110) && (fqu_grn > 70) && (fqu_grn < 86) && (fqu_blau > 42) && (fqu_blau < 53)) 
  { color = 3;} //alle Werte gleich: blau
 
 else if  ((fqu_rot > 200) && (fqu_grn > 200) && (fqu_blau > 200))
  { color = 2;} //alle Werte gleich: schwarz
  
 else if ((fqu_rot < 20) && (fqu_grn < 20) && (fqu_blau < 20))
  { color = 1;}//alle Werte gleich, aber sehr klein: weiss
  
 
 
 else
  { color = 0; }//bisher noch nicht definierter Farbwert
}


void sag_Farbe(void) 
{
 Serial.print("R = ");
 Serial.print(fqu_rot);
 Serial.print(" G = ");
 Serial.print(fqu_grn);
 Serial.print(" B = ");
 Serial.print(fqu_blau);
 Serial.print(" Farbe: ");
 switch (color) 
 {
   case 1: Serial.println("weiss"); break;
   case 2: Serial.println("schwarz"); break;
   case 3: Serial.println("blau"); break;
   case 4: Serial.println("rot"); break;
   default: Serial.println("musst du noch definieren!"); break;
 }
}

void lese_frequenzen(void) 
{
 // hier werden die einzelnen Frequenzen der jeweiligen Farbanteile estimmt und ausgegben
 // damit lassen sich dann die Werte festlegen für die Funktion betimme Farbe
 digitalWrite(S2, LOW);
 digitalWrite(S3, LOW);
 fqu_rot = pulseIn(sensorOut, LOW);
 delay(50);
 digitalWrite(S2, HIGH);
 digitalWrite(S3, HIGH);
 fqu_grn = pulseIn(sensorOut, LOW);
 delay(50);
 digitalWrite(S2, LOW);
 digitalWrite(S3, HIGH);
 fqu_blau = pulseIn(sensorOut, LOW);
 delay(50);
 
}
