#include <Arduino.h>
#include <TM1637Display.h>

// Module connection pins (Digital Pins)
#define CLK 2
#define DIO 3

// The amount of time (in milliseconds) between tests
#define TEST_DELAY   2000
#define dauer 1000 // eine Sekunde
#define  led_dauer 500 // kürzere probieren
#define h_SW 4
#define m_SW 5
#define helligkeit 90  // zum Probieren

#define pos 0 // wird ausgegeben ab Position 0
#define len 4 // die Zahl ist 4 Byte lang
#define lead_zero 1 // führende 0 einfügen: ja
#define dots 0b01000000 // doppelpunkt anzeigen
#define no_dots 0b00000000 // keinen Doppelpunkt anzeigen

unsigned long start;
unsigned long led_start;
unsigned long akt_timer;
unsigned long led_akt_timer;


int h, m, s,Zeit;
boolean ledstatus;
boolean Anz12_24;

const uint8_t SEG_DONE[] = {
	SEG_B | SEG_C | SEG_D | SEG_E | SEG_G,           // d
	SEG_A | SEG_B | SEG_C | SEG_D | SEG_E | SEG_F,   // O
	SEG_C | SEG_E | SEG_G,                           // n
	SEG_A | SEG_D | SEG_E | SEG_F | SEG_G            // E
	};

const uint8_t SEG_xxxx[] = {
  SEG_G,
  SEG_G,
  SEG_G,
  SEG_G
};

TM1637Display display(CLK, DIO);  //erzeuge ein Objekt display  der Klasse TM1637Display 

  /*
  // Selectively set different digits
  data[0] = display.encodeDigit(0);
  data[1] = display.encodeDigit(1);
  data[2] = display.encodeDigit(2);
  data[3] = display.encodeDigit(3);
  display.setSegments(data);
  delay(TEST_DELAY);
  display.setBrightness(7,false);
  display.setSegments(data);
  
  
  display.clear();
  display.setSegments(data+2, 2, 1);
  delay(TEST_DELAY);

  
  delay(TEST_DELAY);
  display.clear();
  display.showNumberDec(-5, false, 3, 0); // Expect: _-5_
 */
  
void setup()
{
  pinMode(h_SW, INPUT_PULLUP);
  pinMode(m_SW, INPUT_PULLUP);
 
  Zeit=1200;
  h = 12;
  m = 0;
  s = 0;
  Anz12_24=1; //0:12h  1: 24h Darstellung
  ledstatus = LOW;
   display.setBrightness(0x0f);
  // All segments on
  display.setSegments(SEG_xxxx);
}
void loop()
{
  delay(50);
  display.showNumberDecEx(Zeit,no_dots,lead_zero,len,pos);
  delay(50);
  display.showNumberDecEx(Zeit,dots,lead_zero,len,pos);

  m++;
  if (s >= 60)
  {
    s = 0;
    m++;
  }
  if (m >= 60)
  {
    m = 0;
    h++;
  }
  if((Anz12_24 == 0) && (h >= 13))
  {
    h = 1;
  }
  
  if((Anz12_24 == 1) && (h >= 24))
  {
    h = 0;
  }
  Zeit = h * 100 + m;
  
}


 
 
