#include <Arduino.h>
#include <TM1637Display.h>

// Module connection pins (Digital Pins)
#define CLK 2
#define DIO 3

// The amount of time (in milliseconds) between tests
#define TEST_DELAY   2000
#define dauer 1000 // eine Sekunde
#define  led_dauer 500 // kürzere probieren
#define SW_h 4
#define SW_m 5
#define helligkeit 90  // zum Probieren

#define pos 0 // wird ausgegeben ab Position 0
#define len 4 // die Zahl ist 4 Byte lang
#define lead_zero 1 // führende 0 einfügen: ja
#define dots 0b01000000 // doppelpunkt anzeigen
#define no_dots 0b00000000 // keinen Doppelpunkt anzeigen

unsigned long start;
unsigned long led_start;
unsigned long timer_akt;
unsigned long timer_old;


int h, m, s,Zeit;
boolean ledstatus;
boolean Anz12_24;
boolean taste_m, taste_h;
boolean dobledot;
boolean dt_am_pm;

const uint8_t SEG_DONE[] = {
	SEG_B | SEG_C | SEG_D | SEG_E | SEG_G,           // d
	SEG_A | SEG_B | SEG_C | SEG_D | SEG_E | SEG_F,   // O
	SEG_C | SEG_E | SEG_G,                           // n
	SEG_A | SEG_D | SEG_E | SEG_F | SEG_G            // E
	};

const uint8_t SEG_xxxx[] = {
  SEG_G,
  SEG_G,
  SEG_G,
  SEG_G
};

TM1637Display display(CLK, DIO);  //erzeuge ein Objekt display  der Klasse TM1637Display 

  /*
  // Selectively set different digits
  data[0] = display.encodeDigit(0);
  data[1] = display.encodeDigit(1);
  data[2] = display.encodeDigit(2);
  data[3] = display.encodeDigit(3);
  display.setSegments(data);
  delay(TEST_DELAY);
  display.setBrightness(7,false);
  display.setSegments(data);
  
  
  display.clear();
  display.setSegments(data+2, 2, 1);
  delay(TEST_DELAY);

  
  delay(TEST_DELAY);
  display.clear();
  display.showNumberDec(-5, false, 3, 0); // Expect: _-5_
 */
  
void setup()
{
  pinMode(SW_h, INPUT_PULLUP);
  pinMode(SW_m, INPUT_PULLUP);

  h = 8;
  m = 0;
  s = 0;
  Anz12_24=1; //0:12h  1: 24h Darstellung
  dt_am_pm=0; //daytime am:0  pm:1
 
  display.setBrightness(0x0f);
  // All segments on
  display.setSegments(SEG_xxxx);
  timer_old=millis();
  dobledot=0;
}
void loop()
{
  timer_akt=millis();

  if(timer_akt > timer_old+500)
  { 
    dobledot = !dobledot;
    timer_old=millis();
    if(dobledot)
      { display.showNumberDecEx(Zeit,dots,lead_zero,len,pos);s++;}
    else
      { display.showNumberDecEx(Zeit,no_dots,lead_zero,len,pos);}
  }
  
  if (s >= 60)
  {
    s = 0;
    m++;
  }
  
  if (m >= 60)
  {
    m = 0;
    h++;
  }
  
  if((Anz12_24 == 0) && (h >= 13))
  {
    h = 1;
    dt_am_pm=1;
  }
  
  if((Anz12_24 == 1) && (h >= 24))
    { h = 0; }
  
  if((Anz12_24 == 1) && (h >= 12))
    { dt_am_pm=1; }
  
  Zeit = h * 100 + m;

  taste_m = digitalRead(SW_m);
  taste_h = digitalRead(SW_h);

  if((!taste_m) && (taste_h))
  {
    delay(50);
    taste_h = digitalRead(SW_h);
    taste_m = digitalRead(SW_m);
    if((!taste_m) && (taste_h))
    { m++;}
    //while(!digitalRead(SW_m));// warte bis losgelassen
    delay(200);
  }  
  
  if((!taste_h) && (taste_m))
  {
    delay(50);
    taste_h = digitalRead(SW_h);
    taste_m = digitalRead(SW_m);
    //if(!taste_h)// diese Abfrage alleine reicht nicht, weil dann nicht exat definiert ist was passiert, wenn die Tasten nicht exakt gleichzeitig gedrückt sind
    if((!taste_h) && (taste_m))
    { h++;}
   //while(!digitalRead(SW_h));// warte bis losgelassen
    delay(200);
  }
 
  if((!taste_h) && (!taste_m))
  {
    delay(50);
    taste_h = digitalRead(SW_h);
    taste_m = digitalRead(SW_m);
    if((!taste_h) && (!taste_m))
    { 
      Anz12_24 = !Anz12_24;
      if(Anz12_24 == 0) // wenn ich von 24h auf 12 h Anzeige wechsle muss ich auch die Zeit umrechnen
      { 
         if(h > 13)
         { 
          h = h - 12; 
         }
      }
      if(Anz12_24 == 1) // wenn ich von 12h auf 24h umwechsle muss ich schauen ob am oder pm ist
      {
        if(dt_am_pm==1) // wenn pm ist muss ich stunden dazu addieren
        {
          h = 12 + h;  
        }
      }
    }
   while((!digitalRead(SW_h)) &&(!digitalRead(SW_m)));// warte bis losgelassen
    delay(200);
  }
  
}


 
 
