// in diesem Beispiel sollen Tastendrücke ausgewertet werden: 
#define LED 13
#define c_digit 3 // wie viele Stellen soll der Code haben
#define LSP 6     // hier koennte man einen Summer anschliessen
#define Frequenz 4800 //Tonhöhe
#define Dauer 500       // 500ms langer Ton 
//Die Ziffern und Zeichen des Keypads werden eingegeben:
int spalte[3]={6,7,8}; //x1, x2, x3
int reihe[4]={9,10,11,12};//y1, y2, y3, y4

uint8_t i,r,s;
char key;
char code_in[c_digit]; //speichere den Char der gedrückten Taste
boolean code_OK;
char code_def[]={'0','8','2'}; // c_digit ist auf 3 gestellt, also nur drei Zeichen erlaubt!
const uint8_t row=4;
const uint8_t col=3;
char Tastenfeld[row][col]=
{// X1  X2  X3
  {'1','2','3'},// Y1
  {'4','5','6'},// Y2
  {'7','8','9'},// Y3
  {'*','0','#'}//  Y4
};

uint8_t key_scan;

void LED_blink(unsigned int pause);// lässt die LED für die Dauer von pause[ms] leuchten, aber ACHTUNG: während dieser Zeit ist keine weitere Eingabe möglich
void key_pressed(void);

void setup()
{
  Serial.begin(9600);
  for(i=9;i <= 13;i++) // PIN 13 ist die LED, deshalb auch auf output!
    { pinMode(i,OUTPUT); digitalWrite(i,HIGH);}//Initialisierung der PINs als OUTPUT und schalten auf HIGH, weil die Pullup den Pegel auch auf High ziehen

  for(i=6;i <= 8;i++)
    { pinMode(i,INPUT_PULLUP); }//Initialisierung der PINs als OUTPUT
  digitalWrite(LED,LOW);
  key_scan=HIGH;
  i=0;
}

void loop()
{
  key=0;
  key_pressed(); // schau ob Taste gedrückt
  if((key !='#') && (key >=0x2A) ) // wenn key eines der Zeichen auf der Tastatur ist, aber nicht '#'
    {                              // dann speichere den Wert im array code_in[]
      Serial.print(key,DEC);
      code_in[i]=key; 
      if(i < c_digit)
        { i++; Serial.print(i,DEC); Serial.print(' '); }
    }

  if(key == '#')                  // wenn key == '#' dann ist die Eingabe beendet
    {
      i=100; // wenn '#' gedrückt dann signalisiere das mit i=100, denn der Code könnte richtig sein
      Serial.println('#');
      for(i=0; i < c_digit; i++)
      {
        if(code_in[i] == code_def[i]) 
          { code_OK=true;  }//so lange  kein Fehler auftritt, dann signalisiere das mit true
        else
          { code_OK = false; }// wenn ein Fehler auftritt, dann signalisiere das mit false
      }

      if(code_OK) // wenn der eingegebene CODE richtig ist, dann ...
        { 
          Serial.print("OK"); 
          // LED_blink(800);  
          // tone(LSP, Frequenz, Dauer);// werte sind oben mit #define festgelegt
        }
      i=0; // i muss wieder 0 werden, für die nächste Eingabe
    }
}//ende von loop



void key_pressed(void)
{
  //Suche nach gedrücktem Knopf
 for(r=0; r <= 3; r++)
 {// zuerst abwechselnd eine Reihe aktiv schalten
     digitalWrite(reihe[r],LOW);// Schalte eine Reihe auf low und schau welche Spalte jetzt auch low ist
     delay(10);
  // dann alle Spalten einlesen und schauen ob ein Knopf gedrückt - > LOW an einem der Spalten-Pins   
  for(s=0; s < 3; s++)
  {
    key_scan=digitalRead(spalte[s]);
    if(key_scan == LOW)
    { //Wenn gedrückter Knopf erkannt, sende Botschaft über RS232
      delay(10);
      key_scan=digitalRead(spalte[s]);    // ist der Pin immernoch high
      if(key_scan == LOW)
      {
        key=Tastenfeld[r][s];
     //   Serial.print("Taste: ");Serial.print(key);Serial.println(" gedrückt");
        do //warte bis losgelassen
         {
           key_scan=digitalRead(spalte[s]);    // ist der Pin immernoch high
           delay(10);
         }
        while(key_scan == LOW);// so lange LOW, bleibe in der Schleife
       }  
     }   
   }// ende for s
  digitalWrite(reihe[r],HIGH);// Schalte eine Reihe auf high und schau welche Spalte auch high ist
 }// ende for r

}



void LED_blink(unsigned int pause)
{
  digitalWrite(LED, HIGH);
  delay(pause);
  digitalWrite(LED,LOW);
}
