// der Vorteil bei definitionen ist, wenn die Werte zu ändern sind, geschiet dies nur an 
// einer Stelle, nämlich am Programmkopf, ansonsten müßten sie im Programm durchsucht werden

#define warte_rt 500  // Hier die Wartezeiten, die in millisekunden angegeben werden
#define warte_ge 300
#define warte_gn 300
#define warten 1000  
// Nun folgen die Pins an denen die LED's angeschlosse sind:
#define LED_rt 13   // beim uno sind die Pins von 0 .. 13 durchnummeriert
                    // analogpins A0 ... A7 genaueres über die Pindefinitionen findest du in dem Verzeichnis
                    //  c:\Program Files (x86)\Arduino\hardware\arduino\avr\variants\standard\pins_arduino.h
#define LED_gn 12
#define LED_ge 11
// ########################    E N D E     D  E  R     D  E  F  I  N  E  S    ###########

// Befehlsabfolgen, die sich wiederholen, können in Unterprogrammen zusammengefasst werden
// Unterprogramme/Funktionen müssen zuerst deklariert werden: 
void switch_rt_on(void);// void bedeutet, dass keine Werte an die Fuktion übergeben werden
void switch_ge_on(void);// und auch, dass keine Werte von der Funktion zurückgegeben werden
void switch_gn_on(void);
void aus(void);
// ########################    E N D E     D  E  R     F U N K T I O N S - D E K L A R A T I O N E N    ###########

unsigned long timer_alt, timer; // eine Variable die als long definiert ist, kann Werte bis 2^32 annhemen
unsigned int beispiel;          // eine Variable int also integer, kann Werte bis 65535 annehmen, unsigned bedeutet ohne Vorzeichen
// ########################    E N D E     D  E  R     V  A R I A B L E N     ###########



void setup() {
  // hier werden initialisierungen der Hardware und der Variablen vorgenommen 
  pinMode(LED_rt, OUTPUT); // hier wird der LED Port als Ausgang definiert
  digitalWrite(LED_rt,LOW);// LED ausschalten
  pinMode(LED_ge, OUTPUT); // hier wird der LED Port als Ausgang definiert
  digitalWrite(LED_ge,LOW);// LED ausschalten
  pinMode(LED_gn, OUTPUT); // hier wird der LED Port als Ausgang definiert
  digitalWrite(LED_gn,LOW);// LED ausschalten
}

// im Gegensatz zu setup() wird loop, wieder der Name schon sagt, permanent durchlaufen
void loop() {
  switch_rt_on(); // zwei Backslash oder mit /* Kommentar */ kann man Zeilen auskommentieren
  switch_ge_on(); // wenn man also vor die Befehle zwei 
                  // macht ist es möglich nur zwei oder eine LED blinken zu lassen
  switch_gn_on(); // probier das einmal aus
  aus();
}// ende von loop

// Ab hier können Unterprogramme definiert werden
// Die Unterprogramme könnten auch oben schon definiert werden, aber es ist Geschmacksache 
// und ich finde es übersichtlicher, wenn die Funktionen unterhalb von loop stehen
// die Reihenfolge der Funktionen spielt dabei keine Rolle

void switch_gn_on(void)
{
  digitalWrite(LED_gn, HIGH);   // grüne LED einschalten
  delay(warte_gn);             //  lasse sie einige ms leuchten
  
}

void switch_ge_on(void)
{
  digitalWrite(LED_ge, HIGH);   // gelbe LED einschalten
  delay(warte_ge);             // lasse sie einige ms leuchten
  
}

void switch_rt_on(void)
{
  digitalWrite(LED_rt, HIGH);   //rote LED einschalten
  delay(warte_rt);             // lasse sie einige ms leuchten
 
}

void aus(void)
{
  digitalWrite(LED_rt, LOW);    // schalte LED aus
  digitalWrite(LED_ge, LOW);    // schalte LED aus
  digitalWrite(LED_gn, LOW);    // schalte LED aus
  delay(warten);             // lasse sie einige ms aus
}
