#define limit_O 200
#define limit_U 10
#define taster 8
#define LED 13
#define gedrueckt 0
#define losgelassen 1

unsigned int zufall;// zufallszahl
unsigned int Tdel; // reaktionszeit abspeichern
boolean v_taster;// variable für Tasterzustand
unsigned long time_start,time_stopp; //werte für start und stopp zeitstempel
unsigned int delta;

void warte_taste(boolean status_taste);// eine funktionm die wartet ob taste gedrueckt oder losgelassen

void setup() 
{
  pinMode(LED, OUTPUT);
  pinMode(taster, INPUT_PULLUP);
  randomSeed(analogRead(0));// da,it wird der erste Wert über einen freien Port zufällig generiert. freier Pin A0!!!!!!
  Serial.begin(9600);
}


void loop() 
{ 
  do    // warte bis taster gedrueckt, dann startet der Zufallsgenerator
  {     // bzw. ein neuer Durchgang
    v_taster=digitalRead(taster);
    delay(50);
  }
  while(v_taster);

  delay(2000); //warte zwei sekunden, bis ich bereit bin, um es spannend zu machen
  
  zufall = random(limit_O);// random erzeugt nur scheinbar zufallszahlen, nach neustart würden sie sich wiederholen
    // zufall enthält einen wert von 0 ... 300
  
  zufall = random(limit_U,limit_O);// random erzeugt nur scheinbar zufallszahlen, nach neustart würden sie sich wiederholen
    // zufall enthält einen wert von 0 ... 300
  Serial.println(zufall);
  digitalWrite(LED, HIGH);   // LED einschalten
  time_start=millis();
  warte_taste(gedrueckt);// wenn taster gedrückt, ist v_taster = 0 und damit die abbruchbedingung erfüllt 
  time_stopp=millis();
  digitalWrite(LED, LOW);   // LED abschalten
  // und somit springt das Programm raus aus der Schleife
  delta=time_stopp-time_start;
  warte_taste(losgelassen);// warte bis taster losgelassen
  Serial.print("die Reaktionszeit betrug: ");Serial.print(delta,DEC);Serial.println(" ms");
  delay(50);
}// ende von loop
//################################################################################


void warte_taste(boolean status_taste)
{
  if(status_taste == gedrueckt)
  {
    do
    {
      v_taster=digitalRead(taster);
      delay(50);
      if(v_taster == gedrueckt)
        { v_taster=digitalRead(taster); }
    }
    while(v_taster);// wenn taster gedrückt, ist v_taster = 0 und damit die abbruchbedingung erfüllt 
  }

  if(status_taste == losgelassen)
  {
    do
     {
      v_taster=digitalRead(taster);
      delay(50);
      if(v_taster == losgelassen)
        { v_taster=digitalRead(taster); }
     }
    while(!v_taster);// warte bis taster losgelassen
    delay(50);
  }
  
}//##### E N D E  V O N  w a r t e _ t a s t e () #######################
//#######################################################################
