#include <Adafruit_BMP280.h>
#include <Wire.h>
#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
#define OLED_WIDTH 128
#define OLED_HEIGHT 64
#define OLED_ADDR 0x3C

#define SCK 13
#define MISO 12
#define MOSI 11
#define CS 10

Adafruit_SSD1306 display(OLED_WIDTH, OLED_HEIGHT, &Wire, OLED_RESET);
Adafruit_BMP280 bmp280(CS, MOSI, MISO, SCK); // erzeuge ein Objekt mit SPI Schnittstelle


float p,a,t;
int d;


void setup() 
{
 Serial.begin(9600);
 Serial.println("bmp280280 test");

 if (!bmp280.begin()) 
 {
 Serial.println(("keine Verbindung zum Sensor!"));
 while (1);
 }
 /* Default settings from datasheet - von adafruit übernommen */
  bmp280.setSampling(Adafruit_BMP280::MODE_NORMAL,     /* Operating Mode. */
                  Adafruit_BMP280::SAMPLING_X2,     /* Temp. oversampling */
                  Adafruit_BMP280::SAMPLING_X16,    /* Pressure oversampling */
                  Adafruit_BMP280::FILTER_X16,      /* Filtering. */
                  Adafruit_BMP280::STANDBY_MS_500); /* Standby time. */

  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); // Adressierung beachten, hier 0x3C!
}


void loop() 
{
  p=bmp280.readPressure();
  p=p/100; // umrechnen in mbar
  d=(int) p;
  t=bmp280.readTemperature();
  //Serial.print( bmp280.readAltitude(971.2),1); // Luftdruck am Ort   Luftdruck = 1013,25 hPa * [ 1 − 6,5 * Höhe / (288150 m) ]^5,255   Höhe z.B. 356m -> p=971mBar bei einem Tiefdruckgebiet erhält man einen negative Höhe
  a=bmp280.readAltitude(1023.25);
  
  Serial.print("Luftdruck: ");
  Serial.print(d);
  Serial.println(" mBar");

  Serial.print("Höhe: ");
  Serial.print(a,1);
  Serial.println(" m");
  
  Serial.print("Temperatur: ");
  Serial.print(t,1);
  Serial.println(" °C");
 // gib nun die Daten am Display aus:
 display.clearDisplay();
 display.setTextColor(WHITE); // BLUE, RED, GREEN, CYAN, MAGENTA, YELLOW 
 display.setTextSize(2);
 display.setCursor(23,0);
 display.print("Pollin:");
 display.setTextSize(1);
 display.setCursor(15,16);
 display.print("Druck: ");
 display.print(p);
 display.print(" mBar ");
 display.setCursor(15,24);
 display.print("Hoehe: ");
 display.print(String(a,1));
 display.print("  m ");
 display.display();
 
 delay(2000);
}
