

#define NOTE_C4  262  // welche Note hat welche Frequenz
#define NOTE_CIS4 277
#define NOTE_D4  294
#define NOTE_DIS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FIS4 370
#define NOTE_G4  392
#define NOTE_GIS4 415
#define NOTE_A4  440
#define NOTE_AIS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CIS5 554

#define LSP 3     // Ansteuertransistor für Tonausgabe an Pin D3 anschließen
#define taster 10 // hier ist der Taster angeschlossen

// hier die individulle melodie:
int melodie[] = {
  NOTE_C4, NOTE_C4, NOTE_G4, NOTE_A4, NOTE_G4, NOTE_A4, NOTE_B4, NOTE_C4
};

// die dauer der noten wird in viertel achtel oder halb ausgegeben
int noteDauer[] = {
  4, 8, 8, 4, 4, 4, 4, 4
};

unsigned int Note;
unsigned int notePlay;
boolean v_taster;


void setup() 
{
  pinMode(taster, INPUT_PULLUP);
}

void loop() 
{
   do
   {
     v_taster=digitalRead(taster);
     if(!v_taster) // wenn taste gedrückt lese nochmal, um sicher zu gehen
        {
          delay(20); // "entprelle" Taste 
          v_taster=digitalRead(taster); 
        }
   }
   while(v_taster);// wenn taster gedrückt oder die Wartezeit abgelaufen dann ist abbruchbedingung erfüllt 

  for (Note = 0; Note < 8; Note++) 
  {
    notePlay = 1000 / noteDauer[Note];
    tone(LSP, melodie[Note], notePlay);

    int PauseZwischenNoten = notePlay * 1.30;// es ist auch moeglich eine variable erst zu definieren, wenn sie gebraucht wird
    delay(PauseZwischenNoten);
   
    noTone(LSP);
  }    

}
