 /*
  
  Verdrahtung des Arduino mit dem MFRC522 Modul:
  ----------------------------------------
              MFRC522      Arduino       
              Reader/PCD   nano          
  Signal      Pin          Pin           
  ----------------------------------------
  RST/Reset   RST          D9             
  SPI SS      SDA(SS)      D10            
  SPI MOSI    MOSI         D11 / ICSP-4   
  SPI MISO    MISO         D12 / ICSP-1   
  SPI SCK     SCK          D13 / ICSP-3    
 */

#include <SPI.h>
#include <MFRC522.h>

#define Baud          19200
#define RST_PIN         9           // Configurable, see typical pin layout above
#define SS_PIN          10          // Configurable, see typical pin layout above

MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance.
MFRC522::MIFARE_Key key;


byte c;

void lese_array(byte *buffer, byte anzahl);

void setup() {
    Serial.begin(Baud);	// Initialize serial communications with the PC
    while (!Serial);    // Do nothing if no serial port is opened (added for Arduinos based on ATMEGA32U4)
    SPI.begin();		// Init SPI bus
    mfrc522.PCD_Init();	// Init MFRC522 card
    Serial.println("warte auf input");
    
}

/**
 * Main loop.
 */
void loop() {
    // Look for new cards
    if (  mfrc522.PICC_IsNewCardPresent())
    {   
      if (mfrc522.PICC_ReadCardSerial())
      { lese_array(mfrc522.uid.uidByte, mfrc522.uid.size);   }
    }   
   mfrc522.PICC_HaltA(); // warte bis Karte entfernt
}

void lese_array(byte *buffer, byte anzahl) 
{

    for (byte i = 0; i < anzahl; i++) 
    {
      Serial.print("0x");       
      Serial.print(buffer[i],HEX);
      Serial.print(" ,");
    }
    Serial.print("\r\n\r\nwarte auf naechste Karte:\r\n"); // statt println() kann auch \r\n verwendet werden 
}
