 
#include <SPI.h>
#include <MFRC522.h>

#define Baud         19200
#define RST_PIN      9           
#define SS_PIN       10          
#define LED          6 
#define Summer       6 // statt der LED kann auch ein Summer über einen Transistor angestuert werden
#define t_delay      1000 // so lange soll die LED leuchten
#define t2_delay     125  // 125us ergibt 4kHz Ton (Periodendauer: 250us)
#define t3_delay     4000 // ergibt bei 4000Hz eine Dauer von 1s
#define max_member   4    // wie viele Karten haben eine Zugangangsberechtigung
       

MFRC522 mfrc522(SS_PIN, RST_PIN);   // erzeuge eine Instanz mfrc522 vom Objekt MFRC522
MFRC522::MIFARE_Key key;

byte option;  //welche Optionen gibt es, eine erkannte KArte anzukündigen
byte c;
int l;
uint8_t success;    // damit soll signalisiert werden dass die ID ein Element von array member ist 
uint8_t uid[] = { 0, 0, 0, 0, 0, 0, 0 };  // array um die bytes der UID zu speichern, aber ir lassen nur Karten mit 4 Bytes zu

unsigned char member[max_member][4] ={             // hier alle Kartendaten eintragen welche Karten sind als berechtigt eingestuft:
                                      {0x77,0x0C,0x31,0xDA},{0xC7,0xB1,0x72,0xB0}, {0x27,0xFC,0x94,0xD9}, {0xB1 ,0xFC ,0xC3 ,0x20}
                                      }; 

void LED_blink(void)
{
    digitalWrite(LED, HIGH);
    delay(t_delay); 
    digitalWrite(LED, LOW);
    delay(t_delay); 
}




void setup() 
{
    Serial.begin(Baud);	// init serielle Datenübertragung
    while (!Serial);    // 
    SPI.begin();		// Init SPI bus
    mfrc522.PCD_Init();	// Init MFRC522 card
    pinMode(LED,OUTPUT);
    digitalWrite(LED,LOW);
    Serial.println("bin bereit!");
}


void loop() 
{
    
    // erwarte neue Karte
    if ( ! mfrc522.PICC_IsNewCardPresent())
        return;
   
    // 
    if ( ! mfrc522.PICC_ReadCardSerial())
        return;

    dump_byte_array(mfrc522.uid.uidByte, mfrc522.uid.size); // einlesen und in ein array speichern
    // suche ob Kartenbsitzer auch Clubmitglied ist:
    c=0;
    success=0;
    for(byte b=0; b < max_member; b++)  // teste alle Mitglieder IDs 
    { 
     do                                 // jetzt vergleiche alle vier HEX-Werte einer ID:
      {
      if(member[b][c] == uid[c])
        { c++; }
      else
        { break; } // sobald ein Wert falsch ist soll die Schleife verlassen werden
      }
      while(c < 4);//wenn c == 4 ist, ist alles OK
  
      if (c == 4)
      { success=1;}  // das mitglied ist registriert!
    }// -----    end of for  

    if(success)
      {
        Serial.println("Herzlich Willkommen\r\n");
        LED_blink(); 
      }
      else
       { Serial.println("kein Zugang");}  // du kommst hier nicht rein
    mfrc522.PICC_HaltA();
    mfrc522.PCD_StopCrypto1();
    Serial.println("bin bereit!");
}


void dump_byte_array(byte *buffer, byte bufferSize) 
{
    for (l = 0; l < bufferSize; l++) 
    { uid[l]=buffer[l]; }
    Serial.println();
}
