 
#include <SPI.h>
#include <MFRC522.h>

#define Baud         19200
#define RST_PIN      9           
#define SS_PIN       10          
#define LED          6 
#define Summer       6 // statt der LED kann auch ein Summer über einen Transistor angestuert werden
#define t_delay      1000 // so lange soll die LED leuchten
#define t2_delay     125  // 125us ergibt 4kHz Ton (Periodendauer: 250us)
#define t3_delay     4000 // ergibt bei 4000Hz eine Dauer von 1s
#define max_member   4    // wie viele Karten haben eine Zugangangsberechtigung
       

MFRC522 mfrc522(SS_PIN, RST_PIN);   // erzeuge eine Instanz mfrc522 vom Objekt MFRC522
MFRC522::MIFARE_Key key;

byte option,option2;  //welche Optionen gibt es, eine erkannte KArte anzukündigen
byte c;
int l;
uint8_t success;    // damit soll signalisiert werden dass die ID ein Element von array member ist 
uint8_t uid[] = { 0, 0, 0, 0, 0, 0, 0 };  // array um die bytes der UID zu speichern, aber ir lassen nur Karten mit 4 Bytes zu

unsigned char member[max_member][4] ={             // hier alle Kartendaten eintragen welche Karten sind als berechtigt eingestuft:
                                      {0x77,0x0C,0x31,0xDA},{0xC7,0xB1,0x72,0xB0}, {0x27,0xFC,0x94,0xD9}, {0xB1 ,0xFC ,0xC3 ,0x20}
                                      }; 

void LED_blink(void)
{
    digitalWrite(LED, HIGH);
    delay(t_delay); 
    digitalWrite(LED, LOW);
    delay(t_delay); 
}


void beep(void)
{
  for(unsigned int l=0; l < t3_delay; l++)
  {
    digitalWrite(LED, HIGH);
    delayMicroseconds(t2_delay); 
    digitalWrite(LED, LOW);
    delayMicroseconds(t2_delay); 
  }  
}



void setup() 
{
    Serial.begin(Baud);	// init serielle Datenübertragung
    while (!Serial);    // 
    SPI.begin();		// Init SPI bus
    mfrc522.PCD_Init();	// Init MFRC522 card
    pinMode(LED,OUTPUT);
    digitalWrite(LED,LOW);
    Serial.println(" bin bereit, zu empfangen !");

    // gewünschte Option einkommentieren!
    // option=1; // LED soll blinken
    // option=2; // Piepston soll ertönen
    // option=3; // LED leuchtet so lange es piepst
    // option=4; // Es soll blinken und pfeiffen
}


void loop() 
{
    // erwarte neue Karte
    if ( ! mfrc522.PICC_IsNewCardPresent())
        return;

    // 
    if ( ! mfrc522.PICC_ReadCardSerial())
        return;

    dump_byte_array(mfrc522.uid.uidByte, mfrc522.uid.size); // einlesen und in ein array speichern
    // suche ob Kartenbsitzer auch Clubmitglied ist:
    c=0;
    success=0;
    for(byte b=0; b < max_member; b++)  // teste alle Mitglieder IDs 
    { 
     do                                 // jetzt vergleiche alle vier HEX-Werte einer ID:
      {
      if(member[b][c] == uid[c])
        { c++; }
      else
        { break; } // sobald ein Wert falsch ist soll die Schleife verlassen werden
      }
      while(c < 4);//wenn c == 4 ist, ist alles OK
  
      if (c == 4)
      { success=1;}  // das mitglied ist registriert!
    }//end of for  

    if(success)
      { 
        Serial.println(" Herzlich Willkommen");
        switch(option)
        {
          case 1: LED_blink();Serial.println(" LED blinkt"); 
          break;
          case 2: beep();Serial.println("trööööööööööööt"); 
          break;
          case 3:  digitalWrite(LED,HIGH); beep(); digitalWrite(LED,LOW);
          break;
          case 4: LED_blink();beep();LED_blink();
          break;
          default: Serial.println(" du bist Mitglied ");// wenn keine option in setup() einkommentiert ist
        }
        
      }// end of if
      else    // du kommst hier nicht rein
      { 
        option2=random(1,6); // option: min ... max-1
        switch(option2)
        //switch(option)// man könnte hier auch option verwenden, dann ändert sich das verhalten bei success auch zufällig
        {
          case 1: Serial.println(" kein Zutritt"); 
          break;
          case 2: Serial.println(" Du bist hier nicht gewollt"); 
          break;
          case 3:  Serial.println(" du bist kein Mitglied ");
          break;
          case 4:  Serial.println(" du kommst hier net rein ");
          break;
          case 5:  Serial.println(" gleich machts BUMM ");
  
        }
        Serial.println("     zieh ab ! ");
      } //----- end of else  
    mfrc522.PICC_HaltA();
    mfrc522.PCD_StopCrypto1();
    Serial.println("\r\n bin wieder bereit!");
}


void dump_byte_array(byte *buffer, byte bufferSize) 
{
    for (l = 0; l < bufferSize; l++) 
    { uid[l]=buffer[l]; }
    Serial.println();
}
