#include <Adafruit_NeoPixel.h> // wichtig ist immer zuerst die library einzubinden
#include <CapacitiveSensor.h>

#define PIN  2 // welcher Pin des arduino gibt die Steuerbefehle aus
#define pause 500 // wie groß ist die pause bis der LED streifen erneut beschriben wird
#define NUMPIXELS 8

// Neu ist bei dieser Bibliothek, dass zuerst ein Object der Bipliothek zu erstellen ist, um sie nutzen zu können
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
// zweite sEiter der Kupferfläche geerdet: 4630 +-20 -> 6620  ca. 200ml im Behälter, Menge ist aber nicht wichtig, die Höhe!
// ohne Masse: 260 .. 280 ohne masse stieg er  1760 ... 1795
CapacitiveSensor   cs_4_2 = CapacitiveSensor(4,2);        // Widerstand zwischen pin 4 & 2, pin 2 ist receive pin, 

unsigned char anz_pixel = 8; // wie viele LED's hat der stripe als variable, weil ich ja selber bestimme wie viele LEDs leuchten

void setup() 
{
   pixels.begin(); // initialisiert den LED streifen
   cs_4_2.set_CS_AutocaL_Millis(0xFFFFFFFF);     
   Serial.begin(9600);
}

void loop() 
{
    pixels.clear(); // schaltet jede LED aus
    long start = millis();
    long total1 =  cs_4_2.capacitiveSensor(30);// 30 sind die Zahl der samples
    Serial.print(millis() - start);         // 
    Serial.println("\t");                   // tab character 
    Serial.print(total1);                   // print sensor output 1
    Serial.println("\t");                   // tab character 
    anz_pixel=2; // hier fehlt noch die Umrechnung der Zeit in anz_pixel!

    for(int i=0; i<NUMPIXELS; i++) 
    { 
      pixels.setPixelColor(i, pixels.Color(0, 150, 0));// welche Farbe soll leuchten
      pixels.setBrightness(64);// wie hell sollen die LEDs leuchten
      pixels.show();   // zeige die aktuellen Einstellungen
      delay(pause); // Pause vor dem nächsten Schleifendurchlauf
    } // ende von for
}
