#include <Adafruit_NeoPixel.h> // wichtig ist immer zuerst die library einzubinden
#define PIN  6 // welcher Pin des arduino gibt die Steuerbefehle aus
#define NUMPIXELS 8 // wie viele LED's hat der stripe 
#define pause 500 // wie groß ist die pause bis der LED streifen erneut beschriben wird
#define TRIG_PIN 2
#define ECHO_PIN 3
#define MIN_entfernung 10
#define MAX_entfernung 40


// Neu ist bei dieser Bibliothek, dass zuerst ein Object der Bipliothek zu erstellen ist, um sie nutzen zu können
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

long dauer, entfernung;
long dist_div = (MAX_entfernung-MIN_entfernung)/NUMPIXELS;// berechne Änderung der Entfernung für eine LED

void setup() 
{
  pinMode(PIN, OUTPUT);
  pinMode(TRIG_PIN, OUTPUT);
  pinMode(ECHO_PIN, INPUT);
  pixels.begin(); // initialisiert den LED streifen
}

void loop()
{
  //messe die Entfernung
  digitalWrite(TRIG_PIN, LOW);
  delayMicroseconds(2);
  digitalWrite(TRIG_PIN, HIGH);
  delayMicroseconds(10);
  digitalWrite(TRIG_PIN, LOW);

  dauer = pulseIn(ECHO_PIN, HIGH);
  entfernung = (dauer*0.0343)/2;
  
  //Set the LEDs
  for (int i = 0; i < NUMPIXELS; ++i)
  {
   if (entfernung > MIN_entfernung+i*dist_div)// schau wie viele LED leuchten dürfen
   {
      pixels.setPixelColor(i, pixels.Color(0, 150, 0));// rot=0; grün =150, blau =0;
   }
   else
   {
      pixels.setPixelColor(i, pixels.Color(0, 0, 0));// 
   }
  }
   pixels.setBrightness(64);// wie hell sollen die LEDs leuchten
   pixels.show();   // Send the updated pixel colors to the hardware.
   delay(pause); // Pause before next pass through loop
}
