// mit diesem Programm sollen Strichcodes eingelesen werden
// diese sind auf einem Papieraufgedruckt
// ein schwarzer Strich absorbiert das Infrarotlicht
// eine weisse Fläche reflektiert das Infrarotlicht
// damit schaltet die Lichtschranke und der PEgel am Eingang ist '0' -> LED leuchtet
// ist die Lichtschranke offen, dann liegt eine "1" am Eingang und die LED ist aus
// wenn ein reflektiertes Signal erkannt wird, leuchtet die LED auf dem Sensor, weisse Fläche: '0'

 
#define IR_in 2  // an diesem Pin wird das Eingangssignal eingelesen
#define max_bit 8 // wie viele Datenbits hat der Strichcode
#define LED 8
#define warte 1

boolean state;
unsigned long time_akt, time_alt;

unsigned int strichCode[max_bit]; // Liste (Array) aus 30 Bytes in dem ich den strichcode abspeichere
unsigned int x; // variable zur Indizierung des obigen Arrays, um auf jedes Listenelement zugreifen zu können
unsigned int bitRate; // wie viele [ms] beträgt eine Bitlänge
unsigned int bitHalb; // halbe Bitrate
void setup () 
{
  pinMode(IR_in, INPUT_PULLUP);                            // Sensor ist Eingang
  Serial.begin(115200);                               // aktiviere serielle Schnittstelle
  pinMode(LED,OUTPUT);
  digitalWrite(LED,HIGH);
  delay(1000);
  digitalWrite(LED,LOW);
  delay(1000);
  digitalWrite(LED,HIGH);
 
}



void loop () 
{
  Serial.println("warte auf Anlegen des Streifencodes -> LED am Sensor: AUS ");             // was tut er?
  Serial.println("warte auf Bewegung"); 
  // gestartet wird, dunkel -> weiss - wenn erster Flankenwechsel von 1 -> 0 erfolgt ist
  
  while(digitalRead(IR_in));  // warte bis LOW (weiss) dann leuchtet die rote LED und Lesevorgang wird gestartet
  time_alt=millis();
  digitalWrite(LED,LOW);
  Serial.println('1');
  while(!digitalRead(IR_in));   // waret auf schwarz (HIGH)     2. Bit             
  digitalWrite(LED,HIGH);   
  // warte auf 1 und messe die Zeit bis zum nächsten einser dann messe die Zeit und halbiere sie -> zeit pro Bit !!
  Serial.println('2');
  while(digitalRead(IR_in));  // warte bis wieder LOW (zweiter weisser  Streifen) 3.Bit
  digitalWrite(LED, LOW);
  Serial.println('3');
  while(!digitalRead(IR_in));   // warte auf HIGH (schwarz)4.Startbit
  digitalWrite(LED,HIGH);
 
  time_akt = millis();           // timestamp für Anfang des dritten Startbit
  Serial.println('4');
  //Serial.println();
  bitRate = time_akt - time_alt; // Zeitdifferenz ausrechnen in der die vier Startbits übertragen wurden
  digitalWrite(LED, LOW);
  bitRate = bitRate / 3;       // jetzt ist die exakte Zeit für ein Bit definiert
   digitalWrite(LED,HIGH);
  bitHalb=bitRate/2;
  delay(bitHalb);            // warte halbe Bit Zeit, dann lese Status, ist eigentlich nich tidentisch mit dem Abtasttheorem
  digitalWrite(LED,LOW);

  
  x=0;
  strichCode[x] = digitalRead(IR_in); // dieser Wert ist falsch???????????????????????
  
  Serial.print(strichCode[x],DEC);Serial.print(' ');
 
  // lese bis bitcounter x > max_bit; mit bit_max ist individuell festzulegen, wie lange ein Bitstream sein soll
  do
  {
    x++; // index im Feld um eines weiter bewegen
      delay(bitRate);
    if(x % 2)
      { digitalWrite(LED,HIGH);}
    else
      { digitalWrite(LED,LOW);}
    strichCode[x] = digitalRead(IR_in);
    Serial.print(strichCode[x],DEC);Serial.print(' ');
  
  }
  while(x < max_bit-1);// mus < sein, weil Index bei 0 anfängt zu zählen, bei Startwert 1 müsste x < max_bit sein!!!
  // ausserdem wird bei 7 noch einmal die Schleife durchlaufen, dann würden 9 Bits ausgegeben
  //gibt trotzdem 9 bit aus ????????????????????????
  digitalWrite(LED,HIGH);
  Serial.println(' ');
  Serial.println(bitRate);
  Serial.print("timestamp für ein Bit: ");Serial.println(bitRate,DEC);
  Serial.println("Decodiert wurden: ");
  for(x=0; x < max_bit; x++)
     {Serial.print(strichCode[x],DEC);Serial.print(", ");}
  Serial.print(max_bit,DEC);Serial.println(" Bit");
  Serial.println("Drücke RESET für neuen Strichcode ");
  time_akt=millis();
  bitRate = time_akt - time_alt; 
  
  Serial.print("so lange dauerte der gesammte Scan: ");Serial.println(bitRate,DEC);
  while(1);
//nun könnte es von vorne beginnen, dazu RESET drücken, denn die Startbedingung steht im Setup(); !!!
}
