// mit diesem Programm sollen Strichcodes eingelesen werden
// diese sind auf einem Papieraufgedruckt
// ein schwarzer Strich absorbiert das Infrarotlicht
// eine weisse Fläche reflektiert das Infrarotlicht
// damit schaltet die Lichtschranke und der PEgel am Eingang ist '0' -> LED leuchtet
// ist die Lichtschranke offen, dann liegt eine "1" am Eingang und die LED ist aus
// wenn ein reflektiertes Signal erkannt wird, leuchtet die LED auf dem Sensor, weisse Fläche: '0'
// um es zu verinfachen zähle ich nur high und low impulse

// hierbei werden nur quasi die größe der weissanteile und der schwarzanteile gezählt
// dieses Verhältnis dient als Mass, die Informationen zu vergleichen
 
#define IR_in 2  // an diesem Pin wird das Eingangssignal eingelesen
#define max_bit 8 // wie viele Datenbits hat der Strichcode
#define LED 8
#define warte 100

boolean state;
unsigned long time_akt, time_alt;
unsigned long delta;

unsigned int strichCode[max_bit]; // Liste (Array) aus 30 Bytes in dem ich den strichcode abspeichere
unsigned int x; // variable zur Indizierung des obigen Arrays, um auf jedes Listenelement zugreifen zu können
unsigned int bitRate; // wie viele [ms] beträgt eine Bitlänge
unsigned int bitHalb; // halbe Bitrate

unsigned char c_high, c_low; 


void setup () 
{
  pinMode(IR_in, INPUT_PULLUP);                            // Sensor ist Eingang
  Serial.begin(115200);                               // aktiviere serielle Schnittstelle
  pinMode(LED,OUTPUT);
  digitalWrite(LED,HIGH);
  delay(1000);
  digitalWrite(LED,LOW);
  delay(1000);
  digitalWrite(LED,HIGH);
  c_high=0;
  c_low=0;
}



void loop () 
{
  Serial.println("warte auf Anlegen des Streifencodes -> LED am Sensor: AUS ");             // was tut er?
  Serial.println("warte auf Bewegung"); 
  // gestartet wird, dunkel -> weiss - wenn erster Flankenwechsel von 1 -> 0 erfolgt ist
  
  while(digitalRead(IR_in));  // warte bis LOW (weiss) dann leuchtet die rote LED und Lesevorgang wird gestartet
  c_high++;
  time_alt=millis();
  do
  {
    delay(warte);             
    if(digitalRead(IR_in))
      { c_high++; }
    else
      { c_low++;  } 
    time_akt=millis();  
    delta=time_akt-time_alt;
  }
  while(delta < 3000);  // warte bis wieder LOW (zweiter weisser  Streifen) 3.Bit
  
  Serial.print("anz high: ");Serial.print(c_high,DEC); Serial.print(" anz low: "); Serial.println(c_low,DEC);
 
  while(1);
//nun könnte es von vorne beginnen, dazu RESET drücken, denn die Startbedingung steht im Setup(); !!!
}
