#include <Servo.h>

#define schrittweite 2 // um wie viel grad soll der motor sich bewegen
#define delta_t 20     // und in welchem Zeitintervall soll dies geschehen
#define p_taster PIN_A0   // schliesse diesmal den Taster an einen analogen Eingang
#define servo_pwm 9   // an D9 soll die PWM des Servo ausgegeben werden
#define warte 180     // wartezeit in Sekunden

Servo Tee_servo;  // damit erzeugt man eine kopie von servo mit mei_servo um es ansprechen zu koennen


int pos = 0;    // variable to store the servo position
boolean v_taste;   // Variable für Zustand des Tastereingangs
unsigned long v_counter, v_start, v_warte;


void hebe(void);
void senke(void);


void setup() 
{
  Tee_servo.attach(servo_pwm);  // mit welchem PWM-Ausgang soll der servo angesteuert werden ?
  pinMode(p_taster, INPUT_PULLUP);
  v_warte=warte*1000; // wartezeit in ms umrechnen
}



void loop() 
{
  // wurde Taste gedrückt?
  do
  {
  v_taste = digitalRead(p_taster);
  if(!v_taste) // wurde taste gedrückt?
    {
      delay(30); // warte, wenn Taste wirklich betätigt, muss sie auch nachher noch gedrückt sein
      v_taste = digitalRead(p_taster); // lese den Zustand der Taste, wenn gedrückt, dann verlasse die while Schleife
    }
  }
  while(v_taste);
  
  senke();// bewege den Teebeutel in die Ausgangsposition
  v_start=millis();
  do
  {
    v_counter=millis();
  }
  while(v_start + v_counter > v_warte); // bleibe in der Schleife, bis Zeit abgelaufen
  hebe(); // wenn die Zeit abgelaufen ist, dann hebe den Teebeutel
}

void hebe(void)
{
  for (pos = 0; pos <= 180; pos += schrittweite) 
  { // bewege in die eine Richtung bis 180°
    Tee_servo.write(pos);              // bewege dich in die neue Position pos
    delay(delta_t);                       // verharre in dieser position
  }
}


void senke(void)
{
   for (pos = 180; pos >= 0; pos -= schrittweite) 
  { // bewege mich wieder zur Ausgangsposition
    Tee_servo.write(pos);               
    delay(delta_t);                       
  }
}
